package it.pf.access.builder;

import java.util.ArrayList;

public class Keys {

	private ArrayList names;
	private ArrayList values;
	int initialCapacity = 0;
	int current = 0;
	
	public Keys(int capacity) {
		names = new ArrayList(capacity);
		values = new ArrayList(capacity);
		current = 0;
		initialCapacity = capacity;
	}
	
	public boolean addKey(String name, Object value) {
		if (current >= initialCapacity)
			return false;
		names.add(current,name);
		values.add(current,value);
		current++;
		return true;
	}
	
	public boolean removeKey(int pos) {
		if (pos >= current)
			return false;
		names.remove(pos);
		values.remove(pos);
		current--;
		return true;
	}
	
	public String getName(int pos) {
		if (pos >= current)
			return null;
		String ret = (String)names.get(pos);
		return ret;
	}
	
	public boolean replaceKey(int pos, String name, Object value) {
		if (pos >= initialCapacity)
			return false;
		if (pos >= current)
			return this.addKey(name, value);
		else {
			names.set(pos,name);
			values.set(pos,value);
		}
		return true;
	}

	public int size() {
		return current;
	}
	
	public Object getValue(int pos) {
		if (pos >= current)
			return null;
		return values.get(pos);
	}

}
