package it.pf.access.builder;

import java.sql.Types;

import it.pf.access.client.ClientLista;
import it.pf.access.client.ClientListaNew;
import it.pf.dbaccess.DataField;
import it.pf.dbaccess.DataRow;
import it.pf.dbaccess.DataSheet;

public class ServerProvider implements ListProvider {

	private DataSheet ds;
	
	public ServerProvider (String dfrom) {
		//ds = new DataSheet(xlsfilename, 0);
		ClientLista cuaalist = new ClientLista(dfrom);
		if (cuaalist.getError() != null) {
			System.out.println(cuaalist.getError());
			ds = null;
		} else {
			String [] cuaas = cuaalist.getCuaas();
			if (cuaas != null) {
				ds = new DataSheet(cuaas.length);
				for (int i=0; i<cuaas.length; i++) {
					DataRow dr = new DataRow();
					dr.addColumn(0, new DataField("CUAA", Types.VARCHAR, cuaas[i]));
					ds.addRow(dr);
				}
			} else {
				ds = null;
			}
		}
		
	}
	
	public DataRow getRow(int i) {
		if (ds != null) {
			return ds.getRow(i);
		} else {
			return null;
		}
	}

	public int size() {
		if (ds != null) {
			return ds.getRowSize();
		} else {
			return 0;
		}
	}

	public DataSheet getDs() {
		return ds;
	}

	public void setDs(DataSheet ds) {
		this.ds = ds;
	}

}
