package it.pf.access.client;

import it.eng.client.servizi.*;
import it.eng.bean.aziendeModificate.xsd.*;
import it.eng.bean.codici.xsd.*;
//import it.eng.bean.fascicolo.xsd.*;
import it.eng.bean.fascicoloInterno2.xsd.*;
import it.pf.access.builder.Keys;
import it.pf.access.builder.Initialize;
import it.pf.access.builder.MainProcess;
import it.pf.access.builder.UtilizziFlat;
import it.pf.base.ConfigSingletonDefaultSetup;
import it.pf.base.ObjectBean;
import it.pf.base.ConfigSingleton;
import it.pf.dbaccess.DataField;
import it.pf.dbaccess.DataRow;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.lang.reflect.Field;
import java.lang.reflect.Method;
import java.net.MalformedURLException;
import java.net.URL;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;
import java.sql.Statement;
import java.sql.Types;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.Properties;
import java.util.Vector;


public class ClientBaseNew {

	private String ddlfile = "tablesddl.sql";
	private String destinationDir;
	
	private String error;

	private String localDBtype = "MDB";
	//private String localDBtype = "H2";
	private String userid = null;
	
	protected DatiAziendaType obanagrafica;
	protected PersonaType[] obpersone;
	protected UnitaAziendaleType[] obunita;
	protected ParticellaType[] obparticelle;
	protected ConduzioneParticellaType obconduzioni;
	protected ZonaType[] obzone;
	protected ContrattoType[] obcontratti;
	protected MacrousoType[] obmacrousi;
	protected ProprietarioType[] obproprietari;
	protected UnitaVitataType[] obuuvv;
	protected VitignoType[] obvitigni;
	protected IscrizioneType[] obiscrizioni;
	
	protected Vector anagrafica;
	protected Vector persone;
	protected Vector unita;
	protected Vector particelle;
	protected Vector conduzioni;
	protected Vector zone;
	protected Vector contratti;
	protected Vector macrousi;
	protected Vector proprietari;
	protected Vector uuvv;
	protected Vector vitigni;
	protected Vector iscrizioni;
	protected Vector pianocolturale;
	
	private String DBfile;

	protected Keys chiavi;
	protected Keys chiavi_uv;
	
	private String databasename;
	private String databasefile;
	private String endpoint_address;
	private String mandato;
	private int timeout;
	private int timeout_default = 60000;
	
	private String decimals = "(15,4)";
	
	public String getDatabasename() {
		return databasename;
	}

	public void setDatabasename(String databasename) {
		this.databasename = databasename;
	}

	public String getDatabasefile() {
		return databasefile;
	}

	public void setDatabasefile(String databasefile) {
		this.databasefile = databasefile;
	}

	public ClientBaseNew() {
		ObjectBean config = ConfigSingleton.getResources();
		if (config == null) {
			Initialize i = new Initialize();
			config = ConfigSingleton.getResources();
		}
		if (config != null) {
			ObjectBean ob = null;
			String str = null;
			/*
			ObjectBean ob = config.getFilteredAttribute("CONFIG:PARAMETERS:PARAMETER", "name", "DB");
			String str = ob.getAttributeValueAsString("value");
			if (str.equals("MDB") || str.equals("H2")) {
				setLocalDBtype(str);
			} else {
				setLocalDBtype("MDB");
			}
			ob = config.getFilteredAttribute("CONFIG:PARAMETERS:PARAMETER", "name", "databasename");
			if (ob != null) {
				str = ob.getAttributeValueAsString("value");
				this.setDatabasename(str);
			} else {
				this.setDatabasename("potvit");
			}
			ob = config.getFilteredAttribute("CONFIG:PARAMETERS:PARAMETER", "name", "databasefile");
			if (ob != null) {
				str = ob.getAttributeValueAsString("value");
				this.setDatabasefile(str);
			} else {
				this.setDatabasefile("potvit.mdb");
			}
			*/
    		ob = config.getFilteredAttribute("CONFIG:PARAMETERS:PARAMETER", "name", "endpoint_address");
    		if (ob != null) {
    			String url = ob.getAttributeValueAsString("value");
    			if (url != null) {
    				try {
						URL u = new URL(url);
						this.setEndpoint_address(url);
					} catch (MalformedURLException e) {
						e.printStackTrace();
					}
    			}
    		}
			ob = config.getFilteredAttribute("CONFIG:PARAMETERS:PARAMETER", "name", "timeout");
			if (ob != null) {
				str = ob.getAttributeValueAsString("value");
				this.setTimeout(str);
			} else {
				this.setTimeout(timeout_default);
			}
			ob = config.getFilteredAttribute("CONFIG:PARAMETERS:PARAMETER", "name", "mandato");
			if (ob != null) {
				str = ob.getAttributeValueAsString("value");
				this.setMandato(str);
			} else {
				this.setMandato("FASCICOLO_INTERNO_V2_REP");
			}
			
			ob = config.getFilteredAttribute("CONFIG:PARAMETERS:PARAMETER", "name", "userid");
    		this.setUserid(ob.getAttributeValueAsString("value"));		//per essere utilizzato dal client al posto del valore del wsdd
		}
	}
	
	
	protected void createTable(String table, String key, Object obj) {
    	Method[] methods = (obj.getClass()).getMethods();
    	//String createTable = "create table "+table+" ( CUAA VARCHAR(16) , NUMERO_DICH VARCHAR(15), PROVINCIA_RIF VARCHAR(3)";
    	String createTable = "create table "+table+" ( "+ key;
    	boolean firstloop = true;
    	for (int j=0; j<methods.length; j++){
			Method method = ((Method)methods[j]);
			String nome = method.getName();
			if (nome!=null && nome.startsWith("get")){
				if (!nome.equals("getSerializer") &&
						!nome.equals("getDeserializer") &&
						!nome.equals("getOMElement") &&
						!nome.equals("getPullParser") &&
						!nome.equals("getTypeDesc") &&
						!nome.equals("getSerializer") &&
						!nome.equals("getClass") &&
						!nome.equals("getClasse")
				){
					Class rc = method.getReturnType();
					//Type rt = method.getGenericReturnType();
					//System.out.println(nome+" - Class:"+rc.getName()+" - Type:"+rt.toString());
					//if (!rc.getName().endsWith("Vector") &&
					//	!rc.getName().endsWith("[]") ) {
					if ( (rc.getName().equals("java.lang.String")) ||
						(rc.getName().equals("java.math.BigInteger")) ||
						(rc.getName().equals("java.math.BigDecimal")) ||
						(rc.getName().equals("java.lang.String")) ) {
						String n = nome.substring(3);
						String t = rc.getName();
						String tipo = "";
						if (t.equals("java.math.BigInteger") ||
							(t.equals("java.lang.Integer"))) {
							tipo = " INTEGER ";
						} else if (t.equals("java.math.BigDecimal")) {
							tipo = " DECIMAL ";							
						} else if (t.endsWith("java.lang.String")) {
							tipo = " VARCHAR(255) ";
						} else {
							tipo = null;
						}
						if (!firstloop) {
							if (tipo != null) {
								String tmp = createTable.trim();
								if (tmp.endsWith(","))
									createTable += " 	"+n+tipo;
								else
									createTable += ",	"+n+tipo;
							}
						} else {
							if (tipo != null)
								createTable += "	"+n+tipo;
							firstloop = false;
						}
					}
				} 
			}
		}
    	createTable += ");";

    	writeSQL(ddlfile,createTable);
	
	}

	
	public String getDBfile() {
		return DBfile;
	}

	public void setDBfile(String bfile) {
		DBfile = bfile;
	}

	protected Keys cloneKeys(Keys kfrom, int newsize) {
		Keys nk = new Keys(newsize);
		for (int i=0; i<kfrom.size(); i++) {
			String name = kfrom.getName(i);
			Object value = kfrom.getValue(i);
			nk.replaceKey(i, name, value);
		}
		return nk;
	}

	protected void copyBean(Object from, Object to) throws java.lang.Exception {
    	Method[] methods = (from.getClass()).getMethods();
    	for (int j=0; j<methods.length; j++){
			Method methodget = ((Method)methods[j]);
			String nome = methodget.getName();
			if (nome!=null && nome.startsWith("get")){
				if (!nome.equals("getSerializer") &&
						!nome.equals("getDeserializer") &&
						!nome.equals("getOMElement") &&
						!nome.equals("getPullParser") &&
						!nome.equals("getTypeDesc") &&
						!nome.equals("getSerializer") &&
						!nome.equals("getClass") &&
						!nome.equals("getClasse")
				) {
					Object value = methodget.invoke(from, null);
					if (value != null) {
						try {
							Method methodset = (to.getClass()).getMethod("set"+methodget.getName().substring(3), value.getClass());
							if (methodset != null) {
								methodset.invoke(to,value);
							}
						} catch (NoSuchMethodException nm) {
							//donothing
						}
					}
				} 
			}
		}
	}

	protected DataRow mapObj2DataRow(Keys keys, Object obj) throws java.lang.Exception {
    	Method[] methods = (obj.getClass()).getMethods();
    	ArrayList names = new ArrayList();
    	ArrayList values = new ArrayList();
    	for (int j=0; j<methods.length; j++){
			Method method = ((Method)methods[j]);
			String nome = method.getName();
			if (nome!=null && nome.startsWith("get")){
				if (!nome.equals("getSerializer") &&
						!nome.equals("getDeserializer") &&
						!nome.equals("getOMElement") &&
						!nome.equals("getPullParser") &&
						!nome.equals("getTypeDesc") &&
						!nome.equals("getSerializer") &&
						!nome.equals("getClass") &&
						!nome.equals("getClasse") &&
						!nome.endsWith("Length")		//aggiunto per evitare i campi contrattiLength e simili
				){
					Class rc = method.getReturnType();
					String t = rc.getName();
					if (t.equals("java.math.BigInteger")
						|| t.equals("java.math.BigDecimal")
						|| t.equals("java.lang.Integer")
						|| t.endsWith("java.lang.String")) {
						Object res = method.invoke(obj, null);
						if (res instanceof Object[] ){
							//donothing
						}else {   //if (res != null){
							names.add(nome.substring(3));
							values.add(res);
						}
					}
				} 
			}
		}
    	DataRow dr = null;
    	int pos = 0;
    	if (keys != null) {
	    	dr = new DataRow(names.size()+keys.size());
	    	for (int i=0; i<keys.size(); i++) {
	    		String fname = keys.getName(i);
	    		int type = Types.VARCHAR;
	    		Object dato = keys.getValue(i);
	    		if (dato instanceof String) {
	    			type = Types.VARCHAR;
	    		} else if (dato instanceof Integer) {
	    			type = Types.INTEGER;
	    		} else if (dato instanceof java.math.BigInteger) {
	    			type = Types.INTEGER;
	    		} else if (dato instanceof java.math.BigDecimal) {
	    			type = Types.DECIMAL;
	    		} else {
	    			type = Types.VARCHAR;
	    		}
	        	DataField keydf = new DataField(fname,type,dato);
	        	dr.addColumn(pos++, keydf);
	    	}
    	} else {
	    	dr = new DataRow(names.size());
    	}
    	for (int i=0; i<names.size(); i++) {
    		int type = Types.VARCHAR;
    		Object dato = values.get(i);
    		if (dato instanceof String) {
    			type = Types.VARCHAR;
    		} else if (dato instanceof Integer) {
    			type = Types.INTEGER;
    		} else if (dato instanceof java.math.BigInteger) {
    			type = Types.INTEGER;
    		} else if (dato instanceof java.math.BigDecimal) {
    			type = Types.DECIMAL;
    		} else {
    			type = Types.VARCHAR;
    		}
    		DataField df = new DataField((String)names.get(i),type,dato);
    		dr.addColumn(i+pos, df);
    	}
		return dr;
	}
	
	public boolean insertDB() {
		boolean rc = insertDB("azienda",anagrafica);
		if (!rc)
			return false;
		rc = insertDB("persone",persone);
		if (!rc)
			return false;
		rc = insertDB("unita",unita);
		if (!rc)
			return false;
		rc = insertDB("particelle",particelle);
		if (!rc)
			return false;
		rc = insertDB("conduzioni",conduzioni);
		if (!rc)
			return false;
		rc = insertDB("zone",zone);
		if (!rc)
			return false;
		rc = insertDB("contratti",contratti);
		if (!rc)
			return false;
		rc = insertDB("macrousi",macrousi);
		if (!rc)
			return false;
		rc = insertDB("proprietari",proprietari);
		if (!rc)
			return false;
		rc = insertDB("unita_vitate",uuvv);
		if (!rc)
			return false;
		rc = insertDB("vitigni",vitigni);
		if (!rc)
			return false;
		rc = insertDB("iscrizioni_uuvv",iscrizioni);
		if (!rc)
			return false;
		else
			return true;
	}

	public boolean insertDB(String table, Vector data) {
		if (data == null)
			return true;
		if (data.size() == 0)
			return true;
		Iterator it = data.iterator();
		while (it.hasNext()) {
			String stmt = "INSERT INTO "+table;
			String cols = " (";
			String values = " VALUES(";
			DataRow dr = (DataRow)it.next();
			cols += getCols(dr)+") ";
			values += getValues(dr)+");";
			stmt += cols+values;

			writeSQL(table,stmt);

		}
		return true;
	}
	
	public boolean insertDB(String table, Vector data, Object otable) {
		if (data == null)
			return true;
		if (data.size() == 0)
			return true;
		Iterator it = data.iterator();
		while (it.hasNext()) {
			String stmt = "INSERT INTO "+table;
			String cols = " (";
			String values = " VALUES(";
			DataRow dr = (DataRow)it.next();
			cols += getCols(dr)+") ";
			values += getValues(dr,otable)+");";
			stmt += cols+values;
			
			writeSQL(table,stmt);

		}
		return true;
	}

	private void writeSQL(String file, String stmt) {
		try {
			if (!file.endsWith(".sql")) {
				file += ".sql";
			}
			FileOutputStream fos = new FileOutputStream(new File(destinationDir+file), true);
			String stmt2write = stmt+"\n";
			fos.write(stmt2write.getBytes());
			fos.close();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}		
	}
	
	private String getCols(DataRow dr) {
		String cols = dr.getColumn(0).getName();
		for (int i=1; i<dr.getColumnSize(); i++) {
			cols += ","+dr.getColumn(i).getName();
		}
		return cols;
	}
	
	
	private String getValues(DataRow dr) {
		String values = "";
		DataField df = dr.getColumn(0);
		if (df.getSqlType() == Types.VARCHAR)
			values += "'"+parseValue(df.getStringValue())+"'";
		else
			values += parseValue(df.getStringValue());
		for (int i=1; i<dr.getColumnSize(); i++) {
			df = dr.getColumn(i);
			if (df.getObjectValue() == null) {
				values += ",null";
			} else {
				if (df.getSqlType() == Types.VARCHAR)
					values += ",'"+parseValue(df.getStringValue())+"'";
				else
					values += ","+parseValue(df.getStringValue());
			}
		}
		return values;
	}

	private String getValues(DataRow dr, Object otable) {
		String values = "";
		DataField df = dr.getColumn(0);			// CUAA
		values += "'"+parseValue(df.getStringValue())+"'";
		/*
		String type = getFieldType(df.getName(), otable);
		if (type.equals("java.lang.String"))
			values += "'"+parseValue(df.getStringValue())+"'";
		else
			values += parseValue(df.getStringValue());
		*/
		String type = null;
		for (int i=1; i<dr.getColumnSize(); i++) {
			df = dr.getColumn(i);
			type = getFieldType(df.getName(), otable);
			if (type.equals("java.lang.String"))
				values += ",'"+parseValue(df.getStringValue())+"'";
			else {
				if (df.getObjectValue() == null) {
					values += ",null";
				} else {
					String v = parseValue(df.getStringValue());
					if (v.length() == 0) {
						if (type.equals("java.math.BigInteger") ||
							type.equals("java.math.BigDecimal")	||
							type.equals("java.lang.Integer"))
							v = "0";
					} 
					values += ","+v;
				}
			}
		}
		return values;
	}
	
	public String parseValue(String s) {
		String ret = s.replace('\'', ' ');
		return ret;
	}

	private String getFieldType(String fieldname, Object otable) {
    	Field[] fields = (otable.getClass()).getDeclaredFields();
    	for (int i=0; i<fields.length; i++) {
    		//System.out.println(i+" -"+fields[i].getName()+" - "+fields[i].getType().getName());
    		if (fieldname.equalsIgnoreCase(fields[i].getName())) {
    			return fields[i].getType().getName();
    		}
    	}
    	return null;
	}
	
	public String getLocalDBtype() {
		return localDBtype;
	}

	public void setLocalDBtype(String localDBtype) {
		this.localDBtype = localDBtype;
	}


	public String getEndpoint_address() {
		return endpoint_address;
	}

	public void setEndpoint_address(String endpoint_address) {
		this.endpoint_address = endpoint_address;
	}

	public int getTimeout() {
		return timeout;
	}

	public void setTimeout(int timeout) {
		this.timeout = timeout;
	}

	public void setTimeout(String timeout) {
		try {
			Integer t = new Integer(timeout);
			this.timeout = t.intValue();
		} catch (NumberFormatException nfe) {
			this.timeout = timeout_default;
		}
	}

	public void gestError(Exception e) {
        setError(e.getMessage());
        e.printStackTrace();
        if (e.getMessage().contains(new String("autenticazione fallita").subSequence(0, 21))) {
        	System.exit(9);
        } else {
        	return;
        }
	}
	
	public String getError() {
		return error;
	}

	public void setError(String error) {
		this.error = error;
	}

	public String getMandato() {
		return mandato;
	}

	public void setMandato(String mandato) {
		this.mandato = mandato;
	}

	public String getUserid() {
		return userid;
	}

	public void setUserid(String userid) {
		this.userid = userid;
	}

	public String getDestinationDir() {
		return destinationDir;
	}

	public void setDestinationDir(String destinationDir) {
		this.destinationDir = destinationDir;
	}

}
