package it.pf.access.client;

import it.eng.client.servizi.*;
import it.eng.bean.aziendeModificate.xsd.*;
import it.eng.bean.codici.xsd.*;
import it.eng.bean.codici.xsd.MessaggioRispostaType;
//import it.eng.bean.fascicolo.xsd.*;
import it.eng.bean.fascicoloInterno2.xsd.*;
import it.pf.access.builder.Keys;
import it.pf.dbaccess.DataField;
import it.pf.dbaccess.DataRow;

import java.io.IOException;
import java.lang.reflect.Method;
import java.rmi.RemoteException;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;
import java.sql.Statement;
import java.sql.Types;
import java.util.ArrayList;
import java.util.Enumeration;
import java.util.Iterator;
import java.util.Properties;
import java.util.Vector;

import org.apache.ws.security.handler.WSHandlerConstants;


/**
 * dato un CUAA genera le informazioni relative a tutte le dichiarazioni di quel CUAA
 * @author Fabbri_P
 *
 */
public class ClientCodici extends ClientBase {


	private CodiceType[] codici;
	private CodiceType o_codici;
	
	/**
	 * @param args
	 * @throws InterruptedException 
	 */
	public static void main(String[] args) throws InterruptedException {
		ClientCodici inst = new ClientCodici();
	}

	public ClientCodici() {
		super();
	}
	
	public void execute() {
        try {
    		FascicoloInternoPortTypeProxy proxy = new FascicoloInternoPortTypeProxy();
			//proxy.setEndpoint("http://agritest.regione.emilia-romagna.it/MandatoWST/services/FascicoloInterno.FascicoloInternoHttpSoap11Endpoint");
			proxy.setEndpoint(this.getEndpoint_address());

			//i due statement seguenti servono per impostare la user da propria configurazione
    		//senza questi la userid viene acquisita dal file wsdd
			FascicoloInternoPortType portType = proxy.getFascicoloInternoPortType();
			((javax.xml.rpc.Stub)portType)._setProperty(WSHandlerConstants.USER, this.getUserid());

			CodiciResponse responseList = proxy.getCodici(this.getMandato());


            MessaggioRispostaType msg2 = responseList.getMessaggioRisposta();

            if (msg2 == null) {
            	this.setError("999 - Il server non risponde!");
            	return;
            }
            
            if (!"000".equalsIgnoreCase(msg2.getCod())) {
				this.setError(msg2.getCod()+" - "+msg2.getMessaggio());
                return;
            } else {
                ListaCodiciType elenco = responseList.getListaCodici();
                int numcodici = elenco.getCodiceLength();
                codici = elenco.getCodice();
                dropTable("C_CODICI");
                o_codici = new CodiceType();
                createTable("C_CODICI","",o_codici);
                for (int i=0; i<codici.length; i++) {
                	CodiceType cod = codici[i];
                	insertTable("C_CODICI", cod);
                }
            }
         } catch (Exception e) {
        	 gestError(e);
        	 return;
         }
		
	}

	public CodiceType[] getCodici() {
		return codici;
	}
	
	private void dropTable(String tableName) {
		String cmd = "drop table "+tableName;
		Connection con = getDirectConnection(this.getDBfile());
		if (con != null) {
			try {
				execSQL(con, cmd);
				con.close();
			} catch (SQLException e) {
				e.printStackTrace();
			}
		}
	}
	
	private void insertTable(String tableName, CodiceType cod) {
		String stmt = "INSERT INTO "+tableName;
		String cols = " ( attr1, attr2, cod, descrizione, dtFine, dtInizio )";
		String values = " VALUES(";
		values += "'"+cod.getAttr1()+"',";
		values += "'"+cod.getAttr2()+"',";
		values += "'"+cod.getCod()+"',";
		values += "'"+parseValue(cod.getDescrizione())+"',";
		values += "'"+cod.getDtFine()+"',";
		values += "'"+cod.getDtInizio()+"' )";
		stmt += cols+values;
		Connection con = getDirectConnection(this.getDBfile());
		if (con != null) {
			try {
				execSQL(con, stmt);
				con.close();
			} catch (SQLException e) {
				e.printStackTrace();
			}
		}
	}

}
