package it.pf.access.client;

import it.eng.client.servizi.*;
import it.eng.bean.aziendeModificate.xsd.*;
import it.eng.bean.codici.xsd.*;
//import it.eng.bean.fascicolo.xsd.*;
import it.eng.bean.fascicoloInterno2.xsd.*;
import it.pf.access.builder.Keys;
import it.pf.dbaccess.DataField;
import it.pf.dbaccess.DataRow;

import java.io.IOException;
import java.lang.reflect.Method;
import java.rmi.RemoteException;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;
import java.sql.Statement;
import java.sql.Types;
import java.util.ArrayList;
import java.util.Enumeration;
import java.util.Iterator;
import java.util.Properties;
import java.util.Vector;

import org.apache.ws.security.handler.WSHandlerConstants;



/**
 * dato un CUAA genera le informazioni relative a tutte le dichiarazioni di quel CUAA
 * @author Fabbri_P
 *
 */
public class ClientFascicolo extends ClientBase {
	
	//private String DBfile;
	
	private String cuaa;

	/**
	 * @param args
	 * @throws InterruptedException 
	 */
	public static void main(String[] args) throws InterruptedException {
		ClientFascicolo inst = new ClientFascicolo("00085770394");
	}

	public ClientFascicolo(String cf) {
		super();
		this.setCuaa(cf);
		anagrafica = new Vector();
		persone = new Vector();
		unita = new Vector();
		particelle = new Vector();
		conduzioni = new Vector();
		zone = new Vector();
		contratti = new Vector();
		macrousi = new Vector();
		proprietari = new Vector();
		uuvv = new Vector();
		vitigni = new Vector();
		iscrizioni = new Vector();
        try {
    		FascicoloInternoPortTypeProxy proxy = new FascicoloInternoPortTypeProxy();
			//proxy.setEndpoint("http://agritest.regione.emilia-romagna.it/MandatoWST/services/FascicoloInterno.FascicoloInternoHttpSoap11Endpoint");
    		proxy.setEndpoint(this.getEndpoint_address());

    		//i due statement seguenti servono per impostare la user da propria configurazione
    		//senza questi la userid viene acquisita dal file wsdd
			FascicoloInternoPortType portType = proxy.getFascicoloInternoPortType();
			((javax.xml.rpc.Stub)portType)._setProperty(WSHandlerConstants.USER, this.getUserid());
			
			FascicoloInternoSiar2Response fascicoloResp = proxy.getFascicolo2(this.getMandato(), cf);


			String retcod = fascicoloResp.getMessaggioRisposta().getCod(); 
			if (!retcod.equals("000")) {
				this.setError(fascicoloResp.getMessaggioRisposta().getCod()+
						" - "+fascicoloResp.getMessaggioRisposta().getMessaggio());
                return;
			} else {
            
                obanagrafica = fascicoloResp.getDatiAnagrafici();
                if (obanagrafica.getIdAzienda() == null) {
                	this.setError("099 - Fascicolo non in anagrafe");
                	return;
                }
				DataRow drd = mapObj2DataRow(null, obanagrafica);	//anagrafica
				anagrafica.add(drd);

				Keys chiave = new Keys(2);
				chiave.addKey("CUAA",cf);
				chiave.addKey("ID_AZIENDA", obanagrafica.getIdAzienda());
				
				PersoneRuoliType persons = fascicoloResp.getPersoneRuoli();
				if (persons != null) {
					int numPersone = persons.getPersoneLength();
					obpersone = persons.getPersone();
					for (int i=0; i < numPersone; i++) {
						PersonaType p = obpersone[i];
						drd = mapObj2DataRow(chiave, p);	//persona
						persone.add(drd);
					}
				}
				
				UnitaAziendaliType units = fascicoloResp.getUnitaAziendali();
				if (units != null) {
					int numUnita = units.getUnitaLength();
					obunita = units.getUnita();
					for (int i = 0; i < numUnita; i++) {
						UnitaAziendaleType u = obunita[i]; 
						drd = mapObj2DataRow(chiave, u);	//unita aziendale
						unita.add(drd);
					}
				}
				
                ConduzioniTerreniType conduzioneTerreni = fascicoloResp.getConduzioniTerreni();

                if (conduzioneTerreni != null) {
                    int numParticelle = conduzioneTerreni.getParticelleLength();
                    obparticelle = conduzioneTerreni.getParticelle();

                    for (int i = 0; i < numParticelle; i++) {
                        ParticellaType p = obparticelle[i];
        				drd = mapObj2DataRow(chiave, p);	//particella	
        				particelle.add(drd);				//			    
        				
        				obconduzioni = p.getConduzione();
    					Keys key = new Keys(1);
    					key.addKey(chiave.getName(0),chiave.getValue(0));	//key = solo CUAA
        				drd = mapObj2DataRow(key, obconduzioni);	//conduzione (possesso)
        				conduzioni.add(drd);

    					key = new Keys(3);
    					key.addKey(chiave.getName(0),chiave.getValue(0));
    					key.addKey("ID_AZIENDA", obconduzioni.getIdAzienda());
    					key.addKey("ID_PARTICELLA", obconduzioni.getIdParticella());
    					//key.addKey("PROGR", obconduzioni.getProgr());
    					//key.addKey("PROGR", new Integer(1));		//eliminato

                        obcontratti = obconduzioni.getContratti();
    					for (int k = 0; k < obconduzioni.getContrattiLength(); k++) {
            				drd = mapObj2DataRow(key, obcontratti[k]);	//zone
            				contratti.add(drd);
        				}

    					obzone = obconduzioni.getZone();
    					for (int k = 0; k < obconduzioni.getZoneLength(); k++) {
            				drd = mapObj2DataRow(key, obzone[k]);	//zone
            				zone.add(drd);
        				}
    					
                        obproprietari = obconduzioni.getProprietari();
        				for (int k = 0; k < obconduzioni.getProprietariLength(); k++) {
            				drd = mapObj2DataRow(key, obproprietari[k]);	//proprietari
            				proprietari.add(drd);
        				}

                        obmacrousi = obconduzioni.getMacrousi();
        				for (int k = 0; k < obconduzioni.getMacrousiLength(); k++) {
            				drd = mapObj2DataRow(key, obmacrousi[k]);	//macrousi
            				macrousi.add(drd);
        				}

    					obuuvv = obconduzioni.getUnitaVitate();
    					for (int k = 0; k < obconduzioni.getUnitaVitateLength(); k++) {
            				drd = mapObj2DataRow(key, obuuvv[k]);	//zone
            				uuvv.add(drd);
            				
        					Keys keyuv = new Keys(4);
        					keyuv.addKey(chiave.getName(0),chiave.getValue(0));
        					keyuv.addKey("ID_AZIENDA", obconduzioni.getIdAzienda());
        					keyuv.addKey("ID_PARTICELLA", obconduzioni.getIdParticella());
        					//keyuv.addKey("PROGR", new Integer(1));	//eliminato
        					keyuv.addKey("UNAR", obuuvv[k].getUnar());
            				if (obuuvv[k].getAltriVitigniLength() > 0) {
            					obvitigni = obuuvv[k].getAltriVitigni();
            					for (int l=0; l < obuuvv[k].getAltriVitigniLength(); l++) {
            						DataRow drd1 = mapObj2DataRow(keyuv, obvitigni[l]);
            						vitigni.add(drd1);
            					}
            				}
            				if (obuuvv[k].getIdoneitaLength() > 0) {
            					obiscrizioni = obuuvv[k].getIdoneita();
            					for (int l=0; l < obuuvv[k].getIdoneitaLength(); l++) {
            						DataRow drd1 = mapObj2DataRow(keyuv, obiscrizioni[l]);
            						iscrizioni.add(drd1);
            					}
            				}
        				}
                    }
                }
            }
         } catch (Exception e) {
        	 gestError(e);
        	 return;
         }
		
	}
	
	
	/*
	public static void writeObj(Object obj) throws java.lang.Exception {
    	Method[] methods = (obj.getClass()).getMethods();
		for (int j=0; j<methods.length; j++){
			Method method = ((Method)methods[j]);
			String nome = method.getName();
			if (nome!=null && nome.startsWith("get")){
				if (!nome.equals("getSerializer") &&
						!nome.equals("getDeserializer") &&
						!nome.equals("getTypeDesc") &&
						!nome.equals("getSerializer") &&
						!nome.equals("getClass")
				){
					Object res = method.invoke(obj, null);
					if (res instanceof Vector ){
							Object[] el = ((Vector)res).getElements();
							System.out.println(nome.toUpperCase().substring(3) + ": ");
							for (int k=0; k < el.length; k++){
								writeObj(el[k]);
							}
						
					}else if (res instanceof Object[] ){
						System.out.println(nome.toUpperCase().substring(3) + ": ");
						Object[] ar = (Object[])res;
						for (int t=0; t < ar.length; t++){
							writeObj(ar[t]);
						}
					}else if (res!=null){
						System.out.println("________________________");
						System.out.println(nome.toUpperCase().substring(3) + ": ");
						System.out.println(res);
						System.out.println("________________________");
					}
				} 
			}
		}		
    }
	
	
	public String getDBfile() {
		return DBfile;
	}

	public void setDBfile(String bfile) {
		DBfile = bfile;
	}
	*/

	public String getCuaa() {
		return cuaa;
	}

	public void setCuaa(String cuaa) {
		this.cuaa = cuaa;
	}


}
