package it.pf.access.client;

import it.eng.client.servizi.*;
import it.eng.bean.aziendeModificate.xsd.*;
import it.eng.bean.aziendeModificate.xsd.MessaggioRispostaType;
import it.eng.bean.codici.xsd.*;
//import it.eng.bean.fascicolo.xsd.*;
import it.eng.bean.fascicoloInterno2.xsd.*;
import it.pf.access.builder.Keys;
import it.pf.dbaccess.DataField;
import it.pf.dbaccess.DataRow;

import java.io.IOException;
import java.lang.reflect.Method;
import java.rmi.RemoteException;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;
import java.sql.Statement;
import java.sql.Types;
import java.util.ArrayList;
import java.util.Enumeration;
import java.util.Iterator;
import java.util.Properties;
import java.util.Vector;

import org.apache.axis.EngineConfiguration;
import org.apache.axis.configuration.FileProvider;
import org.apache.ws.security.handler.WSHandlerConstants;


/**
 * dato un CUAA genera le informazioni relative a tutte le dichiarazioni di quel CUAA
 * @author Fabbri_P
 *
 */
public class ClientListaNew extends ClientBaseNew {


	private String[] cuaas;
	
	/**
	 * @param args
	 * @throws InterruptedException 
	 */
	public static void main(String[] args) throws InterruptedException {
		ClientListaNew inst = new ClientListaNew("01/04/2010");
	}

	public ClientListaNew(String dfrom) {
		super();
        try {
        	EngineConfiguration config = new FileProvider("mandatoWS.wsdd");
            FascicoloInternoLocator locator= new FascicoloInternoLocator(config);    
            FascicoloInternoPortType port= locator.getFascicoloInternoHttpSoap11Endpoint(new java.net.URL(this.getEndpoint_address()));
            ((javax.xml.rpc.Stub)port)._setProperty(WSHandlerConstants.USER, this.getUserid());

        	/*
    		FascicoloInternoPortTypeProxy proxy = new FascicoloInternoPortTypeProxy();
			//proxy.setEndpoint("http://agritest.regione.emilia-romagna.it/MandatoWST/services/FascicoloInterno.FascicoloInternoHttpSoap11Endpoint");
			proxy.setEndpoint(this.getEndpoint_address());
    		
			//i due statement seguenti servono per impostare la user da propria configurazione
    		//senza questi la userid viene acquisita dal file wsdd
			FascicoloInternoPortType portType = proxy.getFascicoloInternoPortType();
			((javax.xml.rpc.Stub)portType)._setProperty(WSHandlerConstants.USER, this.getUserid());

			AziendeModificateResponse responseList = proxy.getAziendeModificate(this.getMandato(), dfrom);
			*/
			AziendeModificateResponse responseList = port.getAziendeModificate(this.getMandato(), dfrom);

            MessaggioRispostaType msg2 = responseList.getMessaggioRisposta();

            if (msg2 == null) {
            	this.setError("999 - Il server non risponde!");
            	return;
            }
            
            if (!"000".equalsIgnoreCase(msg2.getCod())) {
				this.setError(msg2.getCod()+" - "+msg2.getMessaggio());
                return;
            } else {
                ListaAziendeType elenco = responseList.getListaAziende();
                int numazi = elenco.getCuaaLength();
                cuaas = elenco.getCuaa();
                /*
                System.out.println("Numero aziende modificate dal "+dfrom+" = "+numazi);
                for (int i=0; i<cuaas.length; i++) {
                	System.out.println(i+" - "+cuaas[i]);
                }
                */
            }
         } catch (Exception e) {
        	 gestError(e);
        	 return;
         }
		
	}
	
	public String[] getCuaas() {
		return cuaas;
	}


}
