package it.pf.access.client;

import it.eng.fs.constant.LXConstants;
import it.eng.fs.exeption.CallException;
import it.eng.fs.exeption.ConfigException;
import it.eng.fs.services.PianoColturale;
import it.eng.fs.stub.GetPianoColturale;
import it.eng.fs.stub.GetPianoColturaleResponse;
import it.eng.fs.stub.ISWSMacrouso;
import it.eng.fs.stub.ISWSPossesso;
import it.eng.fs.stub.ISWSResponse;
import it.eng.fs.stub.ISWSUtilizzo;
import it.eng.client.servizi.*;
import it.eng.bean.aziendeModificate.xsd.*;
import it.eng.bean.codici.xsd.*;
//import it.eng.bean.fascicolo.xsd.*;
import it.eng.bean.fascicoloInterno2.xsd.*;
import it.pf.access.builder.Keys;
import it.pf.access.builder.UtilizziFlat;
import it.pf.dbaccess.DataField;
import it.pf.dbaccess.DataRow;
import it.pf.dbaccess.DataSheet;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.lang.reflect.Method;
import java.rmi.RemoteException;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;
import java.sql.Statement;
import java.sql.Types;
import java.util.ArrayList;
import java.util.Enumeration;
import java.util.Iterator;
import java.util.Properties;
import java.util.Vector;




/**
 * dato un CUAA genera le informazioni relative a tutte le dichiarazioni di quel CUAA
 * @author Fabbri_P
 *
 */
public class ClientPianoColturaleNew extends ClientBaseNew {

	
	//private String DBfile;
	
	private String cuaa;

	private String RC_OK = "012";
	
	
	/**
	 * @param args
	 * @throws InterruptedException 
	 */
	public static void main(String[] args) throws InterruptedException {
		ClientPianoColturaleNew inst = new ClientPianoColturaleNew("TBNPLA60D42F219N",2010,"/home/paolo/dati/clientFascicoloNew/");
	}

	public ClientPianoColturaleNew(String cf, int annoRiferimento, String destDir) {
		super();
		this.setCuaa(cf);
		this.setDestinationDir(destDir);
		pianocolturale = new Vector();

		PianoColturale client = new PianoColturale();
		client.setPortName(LXConstants.PORT_NAME_DEFAULT);
		client.setAddressPoint(LXConstants.PROTOCOL_AGREA+"://"+LXConstants.IP_AGREA+":"+LXConstants.PORT_AGREA+"/"+LXConstants.SERVICE_AGREA_END_POINT);
		//Configurazione del client per il wss security
		try {
			client.configure();
			client.setTimeOut(10000);
		} catch (ConfigException e) {
			this.setError(e.getMessage());
            e.printStackTrace();
            return;
		}
		GetPianoColturale input = new GetPianoColturale();
		input.setCuaa(cuaa);
		input.setAnnoRiferimento(annoRiferimento);
		input.setScaricaUtilizzi(true);
		
		
		GetPianoColturaleResponse response=null;
		
	
		try {
			//Invocazione del servizio
			response = client.execute(input);
								
			//Stampa messaggi soap request e reaponse
			//System.out.println("*****REQUEST*****");
			//System.out.println(client.getRequestSOAP());
			//System.out.println("*****RESPONSE*****");
			//System.out.println(client.getResponseSOAP());
			/*
			try {
				FileOutputStream fos = new FileOutputStream(new File("/dati/clientOP/pc/"+cf+".xml"));
				fos.write(client.getResponseSOAP().getBytes());
				fos.close();
			} catch (IOException e) {
				e.printStackTrace();
			}
			*/
		} catch (CallException e) {
            this.setError(e.getMessage());
            e.printStackTrace();
            return;
		}
		//System.exit(0);
		//return;
		
		try{
			
			ISWSResponse res=response.getGetPianoColturaleReturn();
					
			Keys chiave = new Keys(1);
			chiave.addKey("CUAA",cuaa);
			
			//Processo la risposta e mi recupero tutti i possessi, e per ogni possesso tutti i macrousi a esso associato.
			//Creo un SourceBean contenente i valori sopra citati.
			if(res!=null){
				String codRet = res.getCodRet();
				if (!codRet.equals(RC_OK)) {
					System.out.print(" **Errore:"+codRet+" - "+res.getMsgRet());
					return;
				} 
				DataSheet output = new DataSheet(2000);
				ISWSPossesso possessi_arr[]=res.getPossessi();
				if(possessi_arr !=null && possessi_arr.length>0){
					for(int i=0;i<possessi_arr.length;i++){
						int counter = 0;
						UtilizziFlat pc = new UtilizziFlat();
						copyBean(possessi_arr[i], pc);

						ISWSMacrouso[] macro=possessi_arr[i].getMacrousi();
						if(macro !=null && macro.length>0){				
							for(int j=0; j<macro.length; j++){
								copyBean(macro[j], pc);
								// System.out.println("  --");
								ISWSUtilizzo[] utilizzi = macro[j].getUtilizzi();
								if (utilizzi != null && utilizzi.length>0) {
									for(int k=0; k<utilizzi.length; k++){
										copyBean(utilizzi[k], pc);
										pianocolturale.add(mapObj2DataRow(chiave, pc));
									}
								} else {
									pianocolturale.add(mapObj2DataRow(chiave, pc));
								}
							}						
						} else {
							pianocolturale.add(mapObj2DataRow(chiave, pc));
						}
					}				
					//output.writeXLS("/home/paolo/tmp/pc.xls");
				}
			}	
				
		}catch(Exception e){
			gestError(e);
			return;
		}
		return;
		
	}
	
	
	/*
	public static void writeObj(Object obj) throws java.lang.Exception {
    	Method[] methods = (obj.getClass()).getMethods();
		for (int j=0; j<methods.length; j++){
			Method method = ((Method)methods[j]);
			String nome = method.getName();
			if (nome!=null && nome.startsWith("get")){
				if (!nome.equals("getSerializer") &&
						!nome.equals("getDeserializer") &&
						!nome.equals("getTypeDesc") &&
						!nome.equals("getSerializer") &&
						!nome.equals("getClass")
				){
					Object res = method.invoke(obj, null);
					if (res instanceof Vector ){
							Object[] el = ((Vector)res).getElements();
							System.out.println(nome.toUpperCase().substring(3) + ": ");
							for (int k=0; k < el.length; k++){
								writeObj(el[k]);
							}
						
					}else if (res instanceof Object[] ){
						System.out.println(nome.toUpperCase().substring(3) + ": ");
						Object[] ar = (Object[])res;
						for (int t=0; t < ar.length; t++){
							writeObj(ar[t]);
						}
					}else if (res!=null){
						System.out.println("________________________");
						System.out.println(nome.toUpperCase().substring(3) + ": ");
						System.out.println(res);
						System.out.println("________________________");
					}
				} 
			}
		}		
    }
	
	
	public String getDBfile() {
		return DBfile;
	}

	public void setDBfile(String bfile) {
		DBfile = bfile;
	}
	*/

	public Vector getPianocolturale() {
		return pianocolturale;
	}
	
	public String getCuaa() {
		return cuaa;
	}

	public void setCuaa(String cuaa) {
		this.cuaa = cuaa;
	}

}
