package test;

import it.eng.client.servizi.*;
import it.eng.bean.aziendeModificate.xsd.*;
import it.eng.bean.codici.xsd.*;
//import it.eng.bean.fascicolo.xsd.*;
import it.eng.bean.fascicoloInterno2.xsd.*;
import it.pf.access.client.ClientBase;

import java.io.FileInputStream;

import java.util.Properties;

import javax.swing.text.ZoneView;


public class TestFascicolo extends ClientBase {
    /**
     * @param args
     */
    public static void main(String[] args) {
        TestFascicolo instance = new TestFascicolo();
    	instance.testFascicolo();
    }

    public TestFascicolo() {
    	super();
    }
    
    private void testFascicolo() {
        try {
    		FascicoloInternoPortTypeProxy proxy = new FascicoloInternoPortTypeProxy();
			proxy.setEndpoint("http://agritest.regione.emilia-romagna.it/MandatoWST/services/FascicoloInterno.FascicoloInternoHttpSoap11Endpoint");
			FascicoloInternoSiar2Response fascicoloResp = proxy.getFascicolo2("FASCICOLO_INTERNO_V2_REP", "MRSCLL36R07G535H");

			String retcod = fascicoloResp.getMessaggioRisposta().getCod(); 
			if (!retcod.equals("000")) {
                System.out.println(fascicoloResp.getMessaggioRisposta().getCod());
                System.out.println(fascicoloResp.getMessaggioRisposta().getMessaggio());
			} else {
                //dati anagrafici
                DatiAziendaType datiAnagrafici = fascicoloResp.getDatiAnagrafici();

                if (datiAnagrafici != null) {
                    System.out.println("CUAA =" + datiAnagrafici.getCuaa());
                    System.out.println("RagioneSociale =" + datiAnagrafici.getRagioneSociale());
                    ContattiType contatti = datiAnagrafici.getContatti();
                    CittaEsteraType cittaestera = datiAnagrafici.getCittaEsteraLegale();
                    IndirizzoType indirizzoLegale = datiAnagrafici.getSedeLegale();
                }

                
                //conduzioni
                ConduzioniTerreniType  conduzioneTerreni = fascicoloResp.getConduzioniTerreni();

                if (conduzioneTerreni != null) {
                    int numParticelle = conduzioneTerreni.getParticelleLength();
                    ParticellaType[] particelle = conduzioneTerreni.getParticelle();

                    for (int i = 0; i < numParticelle; i++) {
                        ParticellaType p = particelle[i];
                        System.out.println("idParticella=" +
                            p.getIdParticella());
                        System.out.println("supCatastale=" +
                            p.getSupCatastale());

                        p.getConduzione();
                        ConduzioneParticellaType conduzione = p.getConduzione();

                        ContrattoType[] contratti = conduzione.getContratti();
                        MacrousoType[] macrousi = conduzione.getMacrousi();
                        ProprietarioType[] proprietari = conduzione.getProprietari();
                        UnitaVitataType[] uuvv = conduzione.getUnitaVitate();
                        ZonaType[] zone = conduzione.getZone();
                        /*
                        for (int j = 0; j < p.getConduzioniLength(); j++) {
                            ConduzioneParticellaType c = cconduzioni[j];
                            System.out.println("supCondotta=" +
                                c.getSupConduzione());
                        }
                        */
                    }
                }
                
                //allevamenti
                AllevamentiType allevamenti = fascicoloResp.getAllevamenti();
                if (allevamenti != null) {
                	int numAllevamenti = allevamenti.getAllevamentoLength();
                    AllevamentoType[] a = allevamenti.getAllevamento();
                    for (int i=0; i<numAllevamenti; i++) {
                    	AllevamentoType allevamento = a[i];
                    	ConsistenzeType consistenze = allevamento.getConsistenze();
                    	int numConsistenze = consistenze.getConsistenzaLength();
                    	ConsistenzaType[] consistenza = consistenze.getConsistenza();
                    	for (int j=0; j<numConsistenze; j++) {
                    		ConsistenzaType c = consistenza[j];
                    	}
                    }
                }
                
                //persone/ruoli
    			PersoneRuoliType persons = fascicoloResp.getPersoneRuoli();
    			if (persons != null) {
    				int numPersone = persons.getPersoneLength();
    				PersonaType[] obpersone = persons.getPersone();
    				for (int i=0; i < numPersone; i++) {
    					PersonaType p = obpersone[i];
    				}
    			}

			}
                


        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    /*
    private static Policy loadPolicy(String xmlPath) throws Exception {
        StAXOMBuilder builder = new StAXOMBuilder(xmlPath);

        Policy policy = PolicyEngine.getPolicy(builder.getDocumentElement());

        Properties props = new Properties();
        props.load(new FileInputStream("repository/conf/org.properties"));

        String WSUserName = props.getProperty("WS_USERNAME");

        RampartConfig rampartConfig = new RampartConfig();
        rampartConfig.setUser(WSUserName);

        rampartConfig.setPwCbClass("it.pf.access.builder.PWCallbackClient");

        policy.addAssertion(rampartConfig);

        return policy;
    }
    */
}
