package it.eng.fs.main;

import it.eng.commons.db.ConnectionManager;
import it.eng.commons.db.ConnectionManagerException;
import it.eng.fs.constant.LXConstants;
import it.eng.fs.exeption.CallException;
import it.eng.fs.exeption.ConfigException;
import it.eng.fs.services.PianoColturale;
import it.eng.fs.stub.GetPianoColturale;
import it.eng.fs.stub.GetPianoColturaleResponse;
import it.eng.fs.stub.GetPianoColturaleService;
import it.eng.fs.stub.GetPianoColturaleServiceLocator;
import it.eng.fs.stub.GetPianoColturaleSoapBindingStub;
import it.eng.fs.stub.GetPianoColturale_PortType;
import it.eng.fs.stub.ISWSAzienda;
import it.eng.fs.stub.ISWSMacrouso;
import it.eng.fs.stub.ISWSPossesso;
import it.eng.fs.stub.ISWSResponse;
import it.eng.fs.util.handlers.PWCallback;

import java.math.BigDecimal;
import java.math.RoundingMode;
import java.net.InetAddress;
import java.net.MalformedURLException;
import java.net.URL;
import java.rmi.Remote;
import java.text.NumberFormat;
import java.util.Locale;
import java.util.PropertyResourceBundle;
import java.util.Random;
import java.util.ResourceBundle;

import org.apache.axis.AxisEngine;
import org.apache.axis.AxisFault;
import org.apache.axis.AxisProperties;
import org.apache.axis.EngineConfiguration;
import org.apache.axis.client.Service;
import org.apache.axis.client.Stub;
import org.apache.axis.configuration.FileProvider;
import org.apache.ws.security.WSConstants;
import org.apache.ws.security.handler.WSHandlerConstants;
import org.apache.ws.security.message.token.UsernameToken;

public class Main {

	

	public static void main(String[] args) throws AxisFault {
		
	
	//	String pippo="simone,de";
		
		
		//System.out.println("pippo: "+pippo.substring(0, pippo.lastIndexOf(",")));
		
		
		//int anno=2009;
		
		//String fonte="FNPC";
		//String anno_rif=Integer.toString(anno);
		//fonte=fonte+anno_rif.substring(anno_rif.length()-2, anno_rif.length());
		
	//	System.out.println(fonte);
		
		//NumberFormat format = NumberFormat.getNumberInstance(Locale.ITALIAN);
		//format.setMinimumFractionDigits(4);
		

		//BigDecimal t= new BigDecimal(123.3466677);
		
		
		//System.out.println(format.format(t));
		
		
		//double d = 123.3466677; 
		//double d2 = 123.3466677; 
		
		double d = 2.12234; 
		double d2 = 3.0; 
		double d3 = 4.0;
		
		BigDecimal bg = new BigDecimal(d); 
		BigDecimal bg2 = new BigDecimal(d2); 
		BigDecimal bg3 = new BigDecimal(d3); 
		
		
		bg = bg.setScale(4, RoundingMode.DOWN); 
		//bg2 = bg2.setScale(4, BigDecimal.ROUND_DOWN);
		
		
		System.out.println (bg.doubleValue()); 
		//System.out.println (bg2.add(bg)); 
		//System.out.println ("tot: "+bg3.divide(bg).multiply(bg2).doubleValue()); 
		
			
		
		
		 PianoColturale client = new PianoColturale();
		client.setPortName(LXConstants.PORT_NAME_DEFAULT);
		client.setAddressPoint(LXConstants.PROTOCOL_AGREA+"://"+LXConstants.IP_AGREA+":"+LXConstants.PORT_AGREA+"/"+LXConstants.SERVICE_AGREA_END_POINT);
		//client.setAddressPoint("http://agreatest.regione.emilia-romagna.it:80/FornituraServiziWS/services/GetPianoColturale");
		//client.setAddressPoint("http://127.0.0.1:9090/FornituraServiziWS/services/GetPianoColturale");
		

		try {
			client.configure();
		} catch (ConfigException e1) {
			e1.printStackTrace();
		}
		
		client.setTimeOut(10000);
				
		GetPianoColturale input = new GetPianoColturale();
			input.setCuaa("PRNTZN57T31F083X");
			input.setAnnoRiferimento(2009);
			//input.setScaricaAzienda(true);
			input.setScaricaUtilizzi(true);
			//input.setScaricaZone(true);
			
		GetPianoColturaleResponse response=null;
		try {
			response = client.execute(input);
		} catch (CallException e) {
			e.printStackTrace();
		}
		ISWSResponse res=response.getGetPianoColturaleReturn();
		
		ISWSAzienda azienda=res.getAzienda();
	
		client.deleteMacroUsi("cuua",azienda);
	
	
		ISWSPossesso possessi[]=res.getPossessi();
	
		System.out.println("possessi num: "+possessi.length);
		
		client.stampaSoapMsg();
		
		for(int i=0;i<possessi.length;i++){
			ISWSMacrouso [] macro;
			macro=possessi[i].getMacrousi();
			
			if(i==0){
				System.out.println("start");
				//System.out.println(possessi[i].getCodProv());
				System.out.println(possessi[i].getSiglaProvincia());
				System.out.println(possessi[i].getDescComune());
				System.out.println(possessi[i].getSezione());//di norma  null				
				System.out.println(possessi[i].getFoglio());
				System.out.println(possessi[i].getParticella());
				System.out.println(possessi[i].getSubalterno());
				System.out.println("fine");
			}
			
			for(int j=0;j<macro.length;j++){
				System.out.println(i+" - "+j+" Codice: "+macro[j].getCodMacrouso());
				System.out.println(i+" - "+j+" Descrizione: "+macro[j].getDescMacrouso());
				System.out.println(i+" - "+j+" Superficie: "+macro[j].getSupMacrouso());		
			}
			
		}
		
		System.out.println(response.getGetPianoColturaleReturn().getCodRet());
		System.out.println(response.getGetPianoColturaleReturn().getMsgRet());
	
		
	}
	
	
	public static void main_s(String a[]){

		ConnectionManager connMan= new ConnectionManager();
		try {
			//String cod=connMan.getCodAzienda("CNSRRT51H15G205N");
			//System.out.println("risultato: "+cod);
			
			//connMan.updateDate(cod);
			
			connMan.insert();
			System.out.println("ok inserito");
		} catch (ConnectionManagerException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

}
