package it.eng.test;


import java.math.BigDecimal;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Date;


import it.eng.bean.fascicoloInterno2.xsd.AllevamentiType;
import it.eng.bean.fascicoloInterno2.xsd.AllevamentoType;
import it.eng.bean.fascicoloInterno2.xsd.ConduzioneParticellaType;
import it.eng.bean.fascicoloInterno2.xsd.ConduzioniTerreniType;
import it.eng.bean.fascicoloInterno2.xsd.ConsistenzaType;
import it.eng.bean.fascicoloInterno2.xsd.ConsistenzeType;
import it.eng.bean.fascicoloInterno2.xsd.ContrattoType;
import it.eng.bean.fascicoloInterno2.xsd.DatiAziendaType;
import it.eng.bean.fascicoloInterno2.xsd.FascicoloInternoSiar2Response;
import it.eng.bean.fascicoloInterno2.xsd.ParticellaType;
import it.eng.bean.fascicoloInterno2.xsd.StatoAziendaType;
import it.eng.client.servizi.FascicoloInternoPortTypeProxy;

public class TestAllevamentiAzienda {

	public static void testGetAllevamentiAzienda(String cuaa, String annoRif) {
		FascicoloInternoPortTypeProxy proxy = new FascicoloInternoPortTypeProxy();
		try {
			//per lo sviluppo		 

			proxy.setEndpoint("http://127.0.0.1:8080/mandatoWS/services/FascicoloInterno.FascicoloInternoHttpSoap11Endpoint");
			//proxy.setEndpoint("http://agritest.regione.emilia-romagna.it/MandatoWST/services/SignOn.SignOnHttpSoap11Endpoint");
			//per il test
			//proxy.setEndpoint("http://agritest.regione.emilia-romagna.it/MandatoWST/"+
			//		"services/FascicoloInterno.FascicoloInternoHttpSoap11Endpoint");
			// per la produzione
			// proxy.setEndpoint("http://agriservizi.regione.emilia-romagna.it/MandatoWS/"+
			//		"services/FascicoloInterno.FascicoloInternoHttpSoap11Endpoint");
			
			//FascicoloInternoSiar2Response response = proxy.getFascicolo2("FASCICOLO_INTERNO_V2_REP", "02149280394");			
			FascicoloInternoSiar2Response response = proxy.getFascicolo2("FASCICOLO_INTERNO_V2_REP", cuaa);
						
			StatoAziendaType statoAzienda = response.getStatoAzienda();
			
			String aziendaPresente = statoAzienda.getAziendaPresente();
						
			
			String aziendaValidata=null;
			String dataValidazione = null;
			
			if(aziendaPresente.equalsIgnoreCase("true")){
				//azienda presente in anagrade
				aziendaValidata = statoAzienda.getAziendaValidata();
				
				if(aziendaValidata.equalsIgnoreCase("true")){
					dataValidazione = statoAzienda.getDataValidazione();
					//se la data di validazione e' maggiore o uguale a DATA_RIF												
						//recupero il quadro anagrafico dell' azienda
						DatiAziendaType datiAzienda = response.getDatiAnagrafici();
						String cuaaAzienda = datiAzienda.getCuaa();
						String ragioneSociale = datiAzienda.getRagioneSociale();
						System.out.println("Azienda con cuaa "+cuaaAzienda+" presente in anagrafe: "+ragioneSociale);
						
						//recupero informazioni degli allevamenti
						AllevamentiType allevamenti = response.getAllevamenti();
						if(allevamenti != null && allevamenti.getAllevamentoLength()>0){							
							for(int i =0; i<allevamenti.getAllevamentoLength(); i++){
								String out="----------------------------------------------------------\n";
								AllevamentoType all = allevamenti.getAllevamento(i);
								out+="\n ha attualmente un allevamento "+all.getCodAllevamento()+" di "+ all.getAllevamentoDescr();
							
								ConsistenzeType consistenze = all.getConsistenze();
								if(consistenze != null && consistenze.getConsistenzaLength()>0){
									int sizeCons =0;
									for(int j=0; j<consistenze.getConsistenzaLength(); j++){
										ConsistenzaType cons = consistenze.getConsistenza(j);
										String annoRifCons = ""+cons.getAnnoRif().intValue();
										//filtro per anno riferimento, altrimenti lo scarto
										if(annoRifCons.equalsIgnoreCase(annoRif)){
											sizeCons++;
											out+="\n con una consistenza "+ cons.getDescrZootecnica()+" di "+cons.getNumCapi()+" capi";
										}
									}
									if(sizeCons==0)
										out+="\n senza nessuna consistenza nell' anno "+annoRif;
										
								}									
									
								System.out.println(out);
							}
							
						}else
							System.out.println("L' azienda non ha allevamenti");						
					
				}else
					System.out.println("Azienda con cuaa "+cuaa+" non validata");
			}else
				System.out.println("Azienda con cuaa "+cuaa+" non presente");
			
	
		} catch (Exception e) {
			e.printStackTrace();
		}		
	}

	
  	public static void main(String[] args) { 
  		
  		
  		System.out.println("inizio :"+System.currentTimeMillis());
  		//testGetAziendeModificate();
  		//testGetFascicolo();
  		testGetAllevamentiAzienda("00175360361","2010");
  		//teststatoAzienda();
  		System.out.println("fine :"+System.currentTimeMillis());
	}
}
