package it.eng.test;


import java.math.BigDecimal;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Date;


import it.eng.bean.fascicoloInterno2.xsd.ConduzioneParticellaType;
import it.eng.bean.fascicoloInterno2.xsd.ConduzioniTerreniType;
import it.eng.bean.fascicoloInterno2.xsd.ContrattoType;
import it.eng.bean.fascicoloInterno2.xsd.DatiAziendaType;
import it.eng.bean.fascicoloInterno2.xsd.FascicoloInternoSiar2Response;
import it.eng.bean.fascicoloInterno2.xsd.ParticellaType;
import it.eng.bean.fascicoloInterno2.xsd.StatoAziendaType;
import it.eng.bean.fascicoloInterno2.xsd.UnitaVitataType;
import it.eng.client.servizi.FascicoloInternoPortTypeProxy;
import it.eng.utils.DateUtil;

public class TestDatiAziendali {


	public static void testGetDatiAziendali(String cuaa, String dataRif,boolean getIban) {
		FascicoloInternoPortTypeProxy proxy = new FascicoloInternoPortTypeProxy();
		try {
			//per lo sviluppo		 

			proxy.setEndpoint("http://127.0.0.1:8080/mandatoWS/services/FascicoloInterno.FascicoloInternoHttpSoap11Endpoint");
			//proxy.setEndpoint("http://agritest.regione.emilia-romagna.it/MandatoWST/services/SignOn.SignOnHttpSoap11Endpoint");
			//per il test
			//proxy.setEndpoint("http://agritest.regione.emilia-romagna.it/MandatoWST/"+
			//		"services/FascicoloInterno.FascicoloInternoHttpSoap11Endpoint");
			// per la produzione
			// proxy.setEndpoint("http://agriservizi.regione.emilia-romagna.it/MandatoWS/"+
			//		"services/FascicoloInterno.FascicoloInternoHttpSoap11Endpoint");
			
			//FascicoloInternoSiar2Response response = proxy.getFascicolo2("FASCICOLO_INTERNO_V2_REP", "02149280394");			
			FascicoloInternoSiar2Response response = proxy.getFascicolo2("FASCICOLO_INTERNO_V2_REP", cuaa);
						
			StatoAziendaType statoAzienda = response.getStatoAzienda();
			
			String aziendaPresente = statoAzienda.getAziendaPresente();
						
			String maxDataVariazPos = statoAzienda.getMaxDataVariazionePossessiAzienda();
			String maxDataVariazIban = statoAzienda.getMaxDataVariazioneIbanAzienda();
			
			
			String aziendaValidata=null;
			String dataValidazione = null;
			
			if(aziendaPresente.equalsIgnoreCase("true")){
				//azienda presente in anagrade
				aziendaValidata = statoAzienda.getAziendaValidata();
				
				if(aziendaValidata.equalsIgnoreCase("true")){
					dataValidazione = statoAzienda.getDataValidazione();
					//se la data di validazione e' maggiore o uguale a DATA_RIF 
					if(
						(DateUtil.isAfter(dataValidazione, dataRif) || DateUtil.isEquals(dataValidazione, dataRif))
						|| isTerreniVariati(maxDataVariazPos,dataRif)
						|| (getIban && isIbanVariati(maxDataVariazIban,dataRif))
					){
												
						//recupero il quadro anagrafico dell' azienda
						DatiAziendaType datiAzienda = response.getDatiAnagrafici();
						String cuaaAzienda = datiAzienda.getCuaa();
						String ragioneSociale = datiAzienda.getRagioneSociale();
						System.out.println("Azienda con cuaa "+cuaaAzienda+" presente in anagrafe: "+ragioneSociale);
						
						//recupero informazioni alle particelle
						ConduzioniTerreniType conduzioniTerreni = response.getConduzioniTerreni();
						//se l' azienda possiede almeno una particella
						if(conduzioniTerreni.getParticelleLength()>0){
							for(int i= 0; i<conduzioniTerreni.getParticelleLength(); i++){
								String out="----------------------------------------------------------\n";
								ParticellaType particella = conduzioniTerreni.getParticelle(i);
								
								//filtro per dataFine non valorizzata, altrimenti scarto la particella
								String dtFinePart = particella.getDataFine();
								if(dtFinePart != null && !dtFinePart.equalsIgnoreCase(""))
									 continue;
																
								out+="\n sulla particella "+
								particella.getCodProv()+" "+
								particella.getCodCom()+" "+
								particella.getSezione()+" "+
								particella.getFoglio()+" "+
								particella.getParticella()+" "+
								" di "+
								particella.getSupCatastale()+" mq \n";
								
								ConduzioneParticellaType conduzione= particella.getConduzione();
								int sizeContratti=0;
								if(conduzione!=null){										
									ContrattoType[] contratti =conduzione.getContratti();
									if(contratti!=null && contratti.length>0){
										//filtro tutti i contratti con data inizioContratto minore uguale a sysdate e data fineContratto null o maggiore a sysdata, altrimenti scarto il contratto
										for(int k=0;k<contratti.length; k++){
											ContrattoType contratto= contratti[k];
											String dtInizioContratto = contratto.getDtInizio();
											String dtFineContratto = contratto.getDtFine();
											
											DateFormat dateFormat = new SimpleDateFormat("dd/MM/yyyy");  
										    Date date = new Date();  
										    String sysdate = dateFormat.format(date);
											
										    if(
										    		(DateUtil.isBefore(dtInizioContratto, sysdate) || DateUtil.isEquals(dtInizioContratto, sysdate))
										    		&&	( (dtFineContratto ==null || dtFineContratto.equalsIgnoreCase("")) || DateUtil.isAfter(dtFineContratto, sysdate))
										    		
										    ){
										    	sizeContratti++;
										    	out+="l'azienda ha attualmente un contratto";
												out+= "\n di "+ 
														contratto.getSupPossesso()+" mq in " +contratto.getFormaPossessoDescr() +
														" valido dal "+contratto.getDtInizio() +" al "+contratto.getDtFine();
										    }
										}	
										if(sizeContratti == 0)
											out+="l'azienda non ha attualmente un contratto";
									}
								}
								System.
								out.println(out);	
							}
							
						}						
					}
				}				
			}else
				System.out.println("Azienda con cuaa "+cuaa+" non presente in anagrafe");
			
		
			
			/*
			
			if(response.getConduzioniTerreni().getParticelleLength()>0){
				//l'azienda conduce/ha condotto nel passato particelle
				ParticellaType[] particelleCondotte=response.getConduzioniTerreni().getParticelle();
				for(int i=0; i<particelleCondotte.length; i++){
					String out="----------------------------------------------------------\n";
					ParticellaType particellaCondotta=particelleCondotte[i];
					out+="\n sulla particella "+
							particellaCondotta.getCodProv()+" "+
							particellaCondotta.getCodCom()+" "+
							particellaCondotta.getSezione()+" "+
							particellaCondotta.getFoglio()+" "+
							particellaCondotta.getParticella()+" "+
							" di "+
							particellaCondotta.getSupCatastale()+" mq \n";
					ConduzioneParticellaType conduzione= particellaCondotta.getConduzione();
									
					if(conduzione.getUnitaVitateLength()>0){						
						//la particella  una particella vitata
						UnitaVitataType[] unitaVitate= particellaCondotta.getConduzione().getUnitaVitate();
						for(int j=0; j<unitaVitate.length; j++){
							UnitaVitataType uv=unitaVitate[j];
							if("S".equalsIgnoreCase(uv.getFlagAttuale()) && "N".equalsIgnoreCase(uv.getFlagCessata())){
								out+="\n e dal "+
								uv.getDtInizioGestione()+
								" al "+
								uv.getDtFineGestione()+
								" una unita vitata di "+
								uv.getSupVitataDich() +" mq di "+
								uv.getVitignoDescr();
							}
		 
						}
					}
					System.out.println(out);	
				}
			}		
			
			*/
		} catch (Exception e) {
			e.printStackTrace();
		}		
	}
	
	protected static boolean isTerreniVariati(FascicoloInternoSiar2Response response, String dataRif) {
		int n_part=0;
		
		//recupero informazioni alle particelle
		ConduzioniTerreniType conduzioniTerreni = response.getConduzioniTerreni();
		//se l' azienda possiede almeno una particella
		if(conduzioniTerreni.getParticelleLength()>0){
			for(int i= 0; i<conduzioniTerreni.getParticelleLength(); i++){
				ParticellaType particella = conduzioniTerreni.getParticelle(i);
				
				String dataVariazioneParticella = particella.getDataVariazione();
				if(DateUtil.isBefore(dataVariazioneParticella, dataRif) || DateUtil.isEquals(dataVariazioneParticella, dataRif))
					n_part++;
				
				ConduzioneParticellaType conduzione= particella.getConduzione();				
				if(conduzione!=null){						
					ContrattoType[] contratti =conduzione.getContratti();
					if(contratti!=null && contratti.length>0){
						for(int k=0;k<contratti.length; k++){
							ContrattoType contratto= contratti[k];
							String dtVariazione = contratto.getDataVariazione();
							if(DateUtil.isBefore(dtVariazione, dataRif) || DateUtil.isEquals(dtVariazione, dataRif))
								n_part++;
						}							
					}
				}
			}
		}
		
		return n_part >0;		
		
	}	
	
	protected static boolean isTerreniVariati(String maxDataVariazPos, String dataRif) {

		if(DateUtil.isBefore(maxDataVariazPos, dataRif) || DateUtil.isEquals(maxDataVariazPos, dataRif))
			return true;
		else
			return false;
		
	}	
	
	
	protected  static boolean isIbanVariati(String maxDataVariazIban, String dataRif) {

		if(DateUtil.isBefore(maxDataVariazIban, dataRif) || DateUtil.isEquals(maxDataVariazIban, dataRif))
			return true;
		else
			return false;
	}
	
	/*
	protected  boolean isIbanVariatiOls() {
		
		// I parametri della query (ID_AZIENDA e DATARIF) 
		// sono gi nella request.
		
		int quanti=0;
		String query="QUERIES.COUNT_IBAN_MODIFICATI_QUERY";

		SourceBean beanCount = Common.executeQuery(query, action );
		SourceBean beanRow= (SourceBean)beanCount.getAttribute("ROW");
		
		if(beanRow!=null){
			quanti=((BigDecimal)beanRow.getAttribute("QUANTI")).intValue();
			if(quanti>0)
				return true;
		}

		return false;
	}
	*/
	
	
  	public static void main(String[] args) { 
  		
  		
  		System.out.println("inizio :"+System.currentTimeMillis());
  		//testGetAziendeModificate();
  		//testGetFascicolo();
  		testGetDatiAziendali("02149280394","20/03/2010", true);
  		//teststatoAzienda();
  		System.out.println("fine :"+System.currentTimeMillis());
	}
}
