package it.eng.test;


import java.math.BigDecimal;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Date;


import it.eng.bean.fascicoloInterno2.xsd.ConduzioneParticellaType;
import it.eng.bean.fascicoloInterno2.xsd.ConduzioniTerreniType;
import it.eng.bean.fascicoloInterno2.xsd.ContrattoType;
import it.eng.bean.fascicoloInterno2.xsd.DatiAziendaType;
import it.eng.bean.fascicoloInterno2.xsd.FascicoloInternoSiar2Response;
import it.eng.bean.fascicoloInterno2.xsd.ParticellaType;
import it.eng.bean.fascicoloInterno2.xsd.StatoAziendaType;
import it.eng.client.servizi.FascicoloInternoPortTypeProxy;
import it.eng.utils.DateUtil;

public class TestDatiPossessi {


	public static void testGetDatiPossessi(String cuaa, String dataRif,boolean getIban) {
		FascicoloInternoPortTypeProxy proxy = new FascicoloInternoPortTypeProxy();
		try {
			//per lo sviluppo		 

			proxy.setEndpoint("http://127.0.0.1:8080/mandatoWS/services/FascicoloInterno.FascicoloInternoHttpSoap11Endpoint");
			//proxy.setEndpoint("http://agritest.regione.emilia-romagna.it/MandatoWST/services/SignOn.SignOnHttpSoap11Endpoint");
			//per il test
			//proxy.setEndpoint("http://agritest.regione.emilia-romagna.it/MandatoWST/"+
			//		"services/FascicoloInterno.FascicoloInternoHttpSoap11Endpoint");
			// per la produzione
			// proxy.setEndpoint("http://agriservizi.regione.emilia-romagna.it/MandatoWS/"+
			//		"services/FascicoloInterno.FascicoloInternoHttpSoap11Endpoint");
			
			//FascicoloInternoSiar2Response response = proxy.getFascicolo2("FASCICOLO_INTERNO_V2_REP", "02149280394");			
			FascicoloInternoSiar2Response response = proxy.getFascicolo2("FASCICOLO_INTERNO_V2_REP", cuaa);
						
			StatoAziendaType statoAzienda = response.getStatoAzienda();
			
			String aziendaPresente = statoAzienda.getAziendaPresente();
						
			
			String aziendaValidata=null;
			String dataValidazione = null;
			
			if(aziendaPresente.equalsIgnoreCase("true")){
				//azienda presente in anagrade
				aziendaValidata = statoAzienda.getAziendaValidata();
				
				if(aziendaValidata.equalsIgnoreCase("true")){
					dataValidazione = statoAzienda.getDataValidazione();
					//se la data di validazione e' maggiore o uguale a DATA_RIF												
						//recupero il quadro anagrafico dell' azienda
						DatiAziendaType datiAzienda = response.getDatiAnagrafici();
						String cuaaAzienda = datiAzienda.getCuaa();
						String ragioneSociale = datiAzienda.getRagioneSociale();
						System.out.println("Azienda con cuaa "+cuaaAzienda+" presente in anagrafe: "+ragioneSociale);
						
						//recupero informazioni alle particelle
						ConduzioniTerreniType conduzioniTerreni = response.getConduzioniTerreni();
						//se l' azienda possiede almeno una particella
						if(conduzioniTerreni.getParticelleLength()>0){
							for(int i= 0; i<conduzioniTerreni.getParticelleLength(); i++){
								String out="----------------------------------------------------------\n";
								ParticellaType particella = conduzioniTerreni.getParticelle(i);
													
								out+="\n sulla particella "+
								particella.getCodProv()+" "+
								particella.getCodCom()+" "+
								particella.getSezione()+" "+
								particella.getFoglio()+" "+
								particella.getParticella()+" "+
								" di "+
								particella.getSupCatastale()+" mq \n";
								
								ConduzioneParticellaType conduzione= particella.getConduzione();
								int sizeContratti=0;
								if(conduzione!=null){										
									ContrattoType[] contratti =conduzione.getContratti();
									if(contratti!=null && contratti.length>0){
										//filtro tutti i contratti con data inizioContratto minore uguale a dataRif e data fineContratto null o maggiore uguale a dataRif, altrimenti scarto il contratto
										for(int k=0;k<contratti.length; k++){
											ContrattoType contratto= contratti[k];
											String dtInizioContratto = contratto.getDtInizio();
											String dtFineContratto = contratto.getDtFine();
											
																		
										    if(
										    		(DateUtil.isBefore(dtInizioContratto, dataRif) || DateUtil.isEquals(dtInizioContratto, dataRif))
										    		&&	( (dtFineContratto ==null || dtFineContratto.equalsIgnoreCase("")) || (DateUtil.isAfter(dtFineContratto, dataRif) || DateUtil.isEquals(dtFineContratto, dataRif)))
										    		
										    ){
										    	sizeContratti++;
										    	out+="l'azienda ha attualmente un contratto";
												out+= "\n di "+ 
														contratto.getSupPossesso()+" mq in " +contratto.getFormaPossessoDescr() +
														" valido dal "+contratto.getDtInizio() +" al "+contratto.getDtFine();
										    }
										}	
										if(sizeContratti == 0)
											out+="l'azienda non ha attualmente un contratto";
									}
								}
								System.out.println(out);	
							}
							
						}						
					
				}else
					System.out.println("Azienda con cuaa "+cuaa+" non validata");
			}else
				System.out.println("Azienda con cuaa "+cuaa+" non presente");
			
	
		} catch (Exception e) {
			e.printStackTrace();
		}		
	}

	
  	public static void main(String[] args) { 
  		
  		
  		System.out.println("inizio :"+System.currentTimeMillis());
  		//testGetAziendeModificate();
  		//testGetFascicolo();
  		testGetDatiPossessi("02149280394","20/03/2010", true);
  		//teststatoAzienda();
  		System.out.println("fine :"+System.currentTimeMillis());
	}
}
