package it.eng.test;

import it.eng.bean.fascicoloInterno2.xsd.ConduzioneParticellaType;
import it.eng.bean.fascicoloInterno2.xsd.ContrattoType;
import it.eng.bean.fascicoloInterno2.xsd.FascicoloInternoSiar2Response;
import it.eng.bean.fascicoloInterno2.xsd.ParticellaType;
import it.eng.bean.fascicoloInterno2.xsd.UnitaVitataType;
import it.eng.client.servizi.FascicoloInternoPortTypeProxy;

public class TestPotenzialeVitivinicolo {


	public static void testGetFascicolo2UV() {
		FascicoloInternoPortTypeProxy proxy = new FascicoloInternoPortTypeProxy();
		try {
			//per lo sviluppo		 
			proxy.setEndpoint("http://localhost:8080/mandatoWS/"+"" +
					"services/FascicoloInterno.FascicoloInternoHttpSoap11Endpoint");
			//per il test
			//proxy.setEndpoint("http://agritest.regione.emilia-romagna.it/MandatoWST/"+
			//		"services/FascicoloInterno.FascicoloInternoHttpSoap11Endpoint");
			// per la produzione
			// proxy.setEndpoint("http://agriservizi.regione.emilia-romagna.it/MandatoWS/"+
			//		"services/FascicoloInterno.FascicoloInternoHttpSoap11Endpoint");
			
			FascicoloInternoSiar2Response response = proxy.getFascicolo2("FASCICOLO_INTERNO_V2_REP", "02149280394");
			
			response.getStatoAzienda().getAziendaPresente();
			
			if(response.getConduzioniTerreni().getParticelleLength()>0){
				//l'azienda conduce/ha condotto nel passato particelle
				ParticellaType[] particelleCondotte=response.getConduzioniTerreni().getParticelle();
				for(int i=0; i<particelleCondotte.length; i++){
					String out="----------------------------------------------------------\n";
					ParticellaType particellaCondotta=particelleCondotte[i];
					out+="\n sulla particella "+
							particellaCondotta.getCodProv()+" "+
							particellaCondotta.getCodCom()+" "+
							particellaCondotta.getSezione()+" "+
							particellaCondotta.getFoglio()+" "+
							particellaCondotta.getParticella()+" "+
							" di "+
							particellaCondotta.getSupCatastale()+" mq \n";
					ConduzioneParticellaType conduzione= particellaCondotta.getConduzione();
					if(conduzione!=null){						
						out+="l'azienda conduce attualmente "+
								conduzione.getTotSupPossesso()+ " mq \n";
						ContrattoType[] contratti =conduzione.getContratti();
						if(contratti!=null && contratti.length>0){
							for(int k=0;k<contratti.length; k++){
								ContrattoType contratto= contratti[k];
								out+= "\n grazie ad un contratto di "+ 
										contratto.getSupPossesso()+" mq in " +contratto.getFormaPossessoDescr() +
										" valido dal "+contratto.getDtInizio() +" al "+contratto.getDtFine();
							}							
						}
					}										
					if(conduzione.getUnitaVitateLength()>0){						
						//la particella  una particella vitata
						UnitaVitataType[] unitaVitate= particellaCondotta.getConduzione().getUnitaVitate();
						for(int j=0; j<unitaVitate.length; j++){
							UnitaVitataType uv=unitaVitate[j];
							if("S".equalsIgnoreCase(uv.getFlagAttuale()) && "N".equalsIgnoreCase(uv.getFlagCessata())){
								out+="\n e dal "+
								uv.getDtInizioGestione()+
								" al "+
								uv.getDtFineGestione()+
								" una unita vitata di "+
								uv.getSupVitataDich() +" mq di "+
								uv.getVitignoDescr();
							}
		 
						}
					}
					System.out.println(out);	
				}
			}					
		} catch (Exception e) {
			e.printStackTrace();
		}		
	}
	
	
  	public static void main(String[] args) { 
  		
  		
  		System.out.println("inizio :"+System.currentTimeMillis());
  		//testGetAziendeModificate();
  		//testGetFascicolo();
  		testGetFascicolo2UV();
  		//teststatoAzienda();
  		System.out.println("fine :"+System.currentTimeMillis());
	}
}
