package it.eng.utils;

import it.eng.bean.fascicoloInterno2.xsd.ConduzioneParticellaType;
import it.eng.bean.fascicoloInterno2.xsd.ConduzioniTerreniType;
import it.eng.bean.fascicoloInterno2.xsd.FascicoloInternoSiar2Response;
import it.eng.bean.fascicoloInterno2.xsd.ParticellaType;

public class Filtro {

	
	//restituisce un array di particelle che contengono almeno un' unita vitata
	public ParticellaType [] executeUnitavitate(FascicoloInternoSiar2Response response){
		ParticellaType [] particelleArr = null;
		try{
			int sizeParticelle=0;
			ConduzioniTerreniType conduzioni = response.getConduzioniTerreni();
			if(conduzioni != null && conduzioni.getParticelleLength() >0){
				
				//ciclo per calcolare il numero di particelle che contengono almeno un' unita vitata
				for(int i= 0; i<conduzioni.getParticelleLength(); i++){
					ParticellaType particella = conduzioni.getParticelle(i);
					if(particella != null){
						ConduzioneParticellaType conduzione = particella.getConduzione();
						if(conduzione != null && conduzione.getUnitaVitateLength() >0 )
							sizeParticelle++;					
					}
				}
				
				//setto l' array di particelle
				if(sizeParticelle > 0){
					
					particelleArr = new ParticellaType[sizeParticelle];
					int item = 0;
					for(int i= 0; i<conduzioni.getParticelleLength(); i++){
						ParticellaType particella = conduzioni.getParticelle(i);
						if(particella != null){
							ConduzioneParticellaType conduzione = particella.getConduzione();
							if(conduzione != null && conduzione.getUnitaVitateLength() >0 ){
								particelleArr[item] = 	particella;
								item++;
							}
						}
					}	
				}
				
				
			}
		}catch(Exception e){
			e.printStackTrace();
		}
		
		
		return particelleArr;
		
		
	}
	
}
