package it.pf.base;

import it.pf.dbaccess.SetupDataSource;

import java.io.InputStream;
import java.util.Iterator;
import java.util.List;

import javax.sql.DataSource;

import org.xml.sax.InputSource;

public class ConfigSingletonDefaultSetup {

	private ObjectBean config;
	private boolean initialized;
	private boolean print;
	
	public ConfigSingletonDefaultSetup(InputStream fis, boolean prt) {
		print = prt;
		initialize(fis);
	}
	
	public ConfigSingletonDefaultSetup(InputStream fis) {
		print = true;
		initialize(fis);
	}

	/**
	 * esegue una inizializzazione del ConfigSingleton per le parti comuni:
	 * datasources e parametri database
	 * @param fis
	 */
	private void initialize(InputStream fis) {
		initialized = false;
		InputSource source = new InputSource(fis);
		try {
			config = new ObjectBean(ObjectBean.fromXMLStream(source));
		} catch (Exception e) {
			e.printStackTrace();
			config = null;
			return;
		}
		if (print) {
			System.out.println(config.getXML());
		}
		ConfigSingleton.setResources(config);
		ConfigSingleton.getInstance();
		ObjectBeanAttribute ds_parms = config.getAttribute("DATA_SOURCE");
		if (ds_parms != null) {
			SetupDataSource dsinst = new SetupDataSource((ObjectBean)ds_parms.get_value());
			DataSource ds = dsinst.getDataSource();
			ConfigSingleton.setDataSource(ds);
		}
		ObjectBeanAttribute dss = config.getAttribute("DATA_SOURCES");
		if (dss != null) {
			List _dss = ((ObjectBean)dss.get_value()).getAttributesAsList("DS");
			Iterator itDS = _dss.iterator();
			while (itDS.hasNext()) {
				ObjectBeanAttribute dsx = (ObjectBeanAttribute)itDS.next();
				ObjectBean obdsx = (ObjectBean)dsx.get_value();
				SetupDataSource setup = new SetupDataSource(obdsx);
				String dsxn = obdsx.getAttributeValueAsString("name");
				DataSource dsxv = setup.getDataSource();
				ConfigSingleton.addDataSource(dsxn, dsxv);
			}
		}

		
	}
	
	public ObjectBean getConfig() {
		return config;
	}

	public boolean isInitialized() {
		return initialized;
	}
}
