/*
 * CycleCountersImpl.java
 *
 * Created on 5 agosto 2005, 15.21
 */

package it.pf.logging;

/**
 *
 * @author filippo
 */
public class CycleCountersImpl implements CycleCounters{
    protected int iiCycleFatal = 0;
    protected int iiCycleWarn = 0;
    protected int iiCycleInfo = 0;
    protected int iiCycleDebug = 0;
    protected int iiCycleException = 0;
    
    /** Creates a new instance of CycleCountersImpl */
    public CycleCountersImpl() {
        
    }
    
    public String getCycleSummary() {
        String lsTemp;
        int liCycleTotal = iiCycleFatal + iiCycleWarn + iiCycleException + iiCycleInfo + iiCycleDebug;
        if (liCycleTotal > 0)
            lsTemp = "Fatal: " + iiCycleFatal + " Warn: " + iiCycleWarn + " Exc: " + iiCycleException +
                    " Info: " + iiCycleInfo + " Debug: " + iiCycleDebug;
        else
            lsTemp = "No errors reported";
        return lsTemp;
    }
    
    public int getCycleCounter(int piType) {
        switch (piType) {
            case WARN : return iiCycleWarn;
            case INFO : return iiCycleInfo;
            case DEBUG : return iiCycleDebug;
            case EXCEPTION : return iiCycleException;
            case FATAL : return iiCycleFatal;
        }
        return 0;
    }
    
    public void resetCycleCounters() {
        iiCycleFatal = 0;
        iiCycleWarn = 0;
        iiCycleException = 0;
        iiCycleInfo = 0;
        iiCycleDebug = 0;
    }
    
    public void addFatal() { iiCycleFatal++;}
    
    public void addWarn() {iiCycleWarn++;}
    
    public void addInfo() {iiCycleInfo++;}
    
    public void addDebug() {iiCycleDebug++;}
    
    public void addException() {iiCycleException++;}
    
}


