/*
 * DailySummary.java
 *
 * Created on 3 agosto 2005, 10.22
 */

package it.pf.logging;

import java.util.Calendar;
import java.util.GregorianCalendar;
import java.util.Locale;

/**
 *
 * @author filippo
 */
public class DailySummary implements EndCycleListener {
    GlobalCounters iCounters;
    boolean ibSummaryNotSent;
    int iiPrevDay = -1;
    final int HOUR_OF_SUMMARY;
    Notify iSender;
    /** Creates a new instance of DailySummary */
    public DailySummary(GlobalCounters pCounters, int pHOUR_OF_SUMMARY, Notify pSender) {
        if ((pCounters == null ) || (pSender == null) )
            throw new RuntimeException("DailyLogger initialized with null parameters");
        iCounters = pCounters;
        ibSummaryNotSent = true;
        HOUR_OF_SUMMARY = pHOUR_OF_SUMMARY;
        iSender = pSender;
    }
    
    public void onEndCycle(String psLabel) {
        Calendar lCalendar =  new GregorianCalendar(Locale.ITALY);
        if (lCalendar.get(Calendar.DAY_OF_MONTH) != iiPrevDay ) {
            iiPrevDay = lCalendar.get(Calendar.DAY_OF_MONTH);
            ibSummaryNotSent = true;
        }
        if ((lCalendar.get(Calendar.HOUR_OF_DAY) >= HOUR_OF_SUMMARY) && ibSummaryNotSent) {
            String lsSubject = "Resoconto";
            String lsTemp = iCounters.getGlobalSummary();
            iCounters.resetGlobalCounters();
            String lsMessage = lsTemp + "\r\n" + psLabel;
            iSender.sendMessage(lsSubject, lsMessage, NotifyImpl.PRIORITY_HIGH);
            ibSummaryNotSent = false;
        }
    }
}
