/*
 * GlobalCountersImpl.java
 *
 * Created on 5 agosto 2005, 15.37
 */

package it.pf.logging;

/**
 *
 * @author filippo
 */
public class GlobalCountersImpl extends CycleCountersImpl implements GlobalCounters{
    int iiFatal;
    int iiWarn;
    int iiInfo;
    int iiDebug;
    int iiException;
    int iiCycleCount;
    
    /** Creates a new instance of GlobalCountersImpl */
    public GlobalCountersImpl() {
        resetGlobalCounters();
    }
    
    public String getGlobalSummary()  {
        String lsBody = "Esecuzione corretta ";
        int liTotal = iiFatal + iiWarn + iiInfo + iiException + iiDebug + iiCycleInfo + 
                      iiCycleDebug + iiCycleException + iiCycleWarn + iiCycleFatal;
         if (liTotal > 0) {
             lsBody = "";
             if (iiFatal > 0)
                 lsBody += "Fatali: " + (iiFatal + iiCycleFatal) + " ";
             if (iiWarn > 0)
                 lsBody += " Allerta: " + (iiWarn + iiCycleWarn) + " ";
             if (iiException > 0)
                 lsBody += " Exc: " + (iiException + iiCycleException) + " ";
             if (iiInfo > 0)
                 lsBody += "Info: " + (iiInfo + iiCycleInfo) + " ";
             if (iiDebug > 0)
                 lsBody += " Debug: " + (iiDebug + iiCycleDebug) + " ";
         }
         lsBody += "\r\nCicli:" + iiCycleCount;
         return lsBody;
    }
    
    public void resetCycleCounters() { 
        iiFatal += iiCycleFatal;
        iiWarn += iiCycleWarn;
        iiException += iiCycleException;
        iiInfo += iiCycleInfo;
        iiDebug += iiCycleDebug;
        iiCycleCount++;
        super.resetCycleCounters();
    }
    
    public void resetGlobalCounters() {
        iiFatal = 0;
        iiWarn = 0;
        iiException = 0;
        iiInfo = 0;
        iiDebug = 0;
        iiCycleCount = 0;    
    }
    
    public int getGlobalCounter(int piType) {
     switch (piType) {
            case WARN : return iiWarn;
            case INFO : return iiInfo;
            case DEBUG : return iiDebug;
            case EXCEPTION : return iiException;
            case FATAL : return iiFatal;
        }
        return 0;
    }
    
    public int getCycleNumber() {return iiCycleCount;} 
}
