/*
 * LogCycleImpl.java
 *
 * Created on 15 giugno 2005, 11.44
 */

package it.pf.logging;

import java.io.BufferedWriter;
import java.io.FileWriter;
import java.text.SimpleDateFormat;
import java.util.*;

/**
 *
 * @author filippo
 */
public class LogCycleImpl implements LogCycle {
    
    int iiPrevLogDay;
    //int iiCycleFatal;
    //int iiCycleWarn;
    //int iiCycleInfo;
    //int iiCycleDebug;
    //int iiCycleException;
    LogBasic iLogBasic;
    List iListenerList;
    CycleCounters iCounter;
    
    /** Creates a new instance of LogCycleImpl */
    public LogCycleImpl(LogBasic pBasicLogger, CycleCounters pCounter) {
        if ((pBasicLogger == null) || (pCounter == null))
            throw new RuntimeException("LogCycleImpl istantiated with null parameters");
        iLogBasic = pBasicLogger;
        iCounter = pCounter;
        Calendar lCalendar =  new GregorianCalendar(Locale.ITALY);
        iLogBasic.createNewLogger(lCalendar);
        iListenerList = new ArrayList();
    }
    
    public void createNewLogger(Calendar lCalendar) {
        iLogBasic.createNewLogger(lCalendar);
        iiPrevLogDay = lCalendar.get(Calendar.DAY_OF_MONTH);
     }
    
    public void startCycle(String psMessage) {
        //resetCycleCounters(); 
        Calendar lCalendar =  new GregorianCalendar(Locale.ITALY);
        if (lCalendar.get(Calendar.DAY_OF_MONTH) != iiPrevLogDay ) {
            createNewLogger(lCalendar);
        }
        iLogBasic.logLabel("-------------------------------->" + psMessage);
     }
     
     public void endCycle(String psSign) {
        Iterator lListenerIterator = iListenerList.iterator();
        while (lListenerIterator.hasNext())
            ((EndCycleListener)lListenerIterator.next()).onEndCycle(psSign);  
        iLogBasic.logLabel(iCounter.getCycleSummary());
        if (psSign != null) iLogBasic.logLabel(psSign);
        iLogBasic.logLabel("--------------------------------> End Cycle");
        iCounter.resetCycleCounters();       
     }

         
      public void addEndCycleListener(EndCycleListener pListener) {
          if (pListener != null)
            iListenerList.add(pListener);
      }
       
    public void logWarn(String psMessage) {iCounter.addWarn(); iLogBasic.logWarn(psMessage);}
    public void logDebug(String psMessage){iCounter.addDebug(); iLogBasic.logDebug(psMessage);}
    public void logInfo(String psMessage) {iCounter.addInfo(); iLogBasic.logInfo(psMessage);}
    public void logFatal(String psMessage) {iCounter.addFatal(); iLogBasic.logFatal(psMessage);}
    public void logException(String sign, Exception e) {iCounter.addException(); iLogBasic.logException(sign, e);}
    public void logLabel(String psMessage) {iLogBasic.logLabel(psMessage);}
    public void logException(Exception e) {iCounter.addException(); iLogBasic.logException(e);}
}
