/*
 * NotifyLogger.java
 *
 * Created on 3 agosto 2005, 9.46
 */

package it.pf.logging;

import java.util.Calendar;

/**
 *
 * @author filippo
 */
public class NotifyLogger implements LogCycle {
    
    LogCycle iCycleLogger;
    EntryListener iEntryListener;
    boolean lbInsideCycle;
    /** Creates a new instance of NotifyLogger */
    public NotifyLogger(LogCycle pLogger, EntryListener pEntry) {
        if ((pLogger == null) || (pEntry == null))
            throw new RuntimeException("NotifyLogger istantiated with null parameters");
        iCycleLogger = pLogger;
        iEntryListener = pEntry;
        lbInsideCycle = false;
    }
    
    public void logLabel(String psMessage) {iCycleLogger.logLabel(psMessage);}
    
    public void logWarn(String psMessage) {
        iCycleLogger.logWarn(psMessage);
        iEntryListener.addWarn(psMessage, lbInsideCycle);
    }
    
    public void logDebug(String psMessage){iCycleLogger.logDebug(psMessage);}
    public void logInfo(String psMessage){iCycleLogger.logInfo(psMessage);}
    
    public void logFatal(String psMessage){
        iCycleLogger.logFatal(psMessage);
        iEntryListener.addFatal(psMessage, lbInsideCycle);
    }
    
    public void logException(Exception e){
        iCycleLogger.logException(e);
        iEntryListener.addException("", e, lbInsideCycle);
    }
    
    public void logException(String sign, Exception e){
        iCycleLogger.logException(sign, e);
        iEntryListener.addException(sign, e, lbInsideCycle);
    }
    
    public void createNewLogger(Calendar lCalendar){iCycleLogger.createNewLogger(lCalendar);}

    public void startCycle(String psMessage){
        lbInsideCycle = true;
        iCycleLogger.startCycle(psMessage);
    }
    
    public void endCycle(String psMessage){
        lbInsideCycle = false;
        iCycleLogger.endCycle(psMessage);
    }
    
    public void addEndCycleListener(EndCycleListener pListener){iCycleLogger.addEndCycleListener(pListener);}
}
