package it.pf.scheduler;

import java.io.*;
import java.text.*;
import java.util.Calendar;
import java.util.Date;
/**
 * classe di esempio per testare lo scheduler
 * @author Fabbri_P
 *
 */
public class FileScheduler extends Scheduler {

	private Date dateToSchedule;
	
    public FileScheduler() {
		super();
    }

	public void run(String fileName) {
		dateToSchedule = new Date(); // today
		dateToSchedule.setHours(11); // start schedule hour
		dateToSchedule.setMinutes(48); // start schedule minutes
		try {
			readFile(fileName);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
    private void readFile(String fileName) throws IOException, InterruptedException {
        System.out.println("Reading file " + fileName + "...");
		BufferedReader in = new BufferedReader(new FileReader(fileName));

		long sleeptime = 0;
		Calendar start = Calendar.getInstance();
		start.setTime(dateToSchedule);
		long starttime = start.getTimeInMillis();
        String line = null;
        int i = 0;
        int minuti = 2;
        while(true) {
			line = in.readLine();
            if(line == null)
                break;

			System.out.println("Parsing line "+(i++)+": " + line);

            try {
				Calendar c = Calendar.getInstance();
				c.setTime(dateToSchedule);
				c.add(Calendar.MINUTE,minuti);
				dateToSchedule = c.getTime();
				scheduleCommand(line,dateToSchedule);
				System.out.println("Command scheduled at:"+dateToSchedule.toString());
            } catch(ParseException pe) {
				System.out.println("Invalid date : " + pe.getMessage());
            }
        }

		System.out.println("**** Scheduling terminated ****");
        in.close();
		Calendar end = Calendar.getInstance();
		end.setTime(dateToSchedule);
		long endtime = end.getTimeInMillis();
		sleeptime = endtime - starttime;
		sleep(sleeptime);
    }


    public static void main(String[] argv) {
    	FileScheduler inst = null;
		try {
			inst = new FileScheduler();
			inst.run(argv[0]);
			System.out.println("**** ended ****");
			/*
			long delay = 131 + 10;
			System.out.println("**** waiting "+delay+" ****");
			inst.wait(delay*1000);
			System.out.println("**** ended ****");
			*/
		} catch(Exception e) {
			e.printStackTrace();
        }
        System.exit(0);
    }

}
