package it.pf.utils;

import java.sql.Date;
import java.sql.Timestamp;
import java.util.Calendar;
import java.util.StringTokenizer;

/**
 * Bean per il trattamento delle date.
 * Creation date: (8/6/01 12:25:31 PM)
 * @author: Administrator
 */
public final class DataUtil {
    private java.lang.String datainterna = null;
    private Calendar now = null;
    private java.lang.String endDate = "9999-12-31";
    private int coef1;
    private int coef2;
    private boolean valid;
    private String pasqualim = "";

    private static Object[] formats = {
    	"AAAAMMGG", new Integer(0), new Integer(4), new Integer(6),
    	"YYYYMMDD", new Integer(0), new Integer(4), new Integer(6),
    	"aaaammgg", new Integer(0), new Integer(4), new Integer(6),
    	"yyyymmdd", new Integer(0), new Integer(4), new Integer(6),
    	"GG.MM.AAAA", new Integer(6), new Integer(3), new Integer(0),
    	"gg.mm.aaaa", new Integer(6), new Integer(3), new Integer(0),
    	"DD.MM.YYYY", new Integer(6), new Integer(3), new Integer(0),
    	"dd.mm.yyyy", new Integer(6), new Integer(3), new Integer(0),
    	"GG/MM/AAAA", new Integer(6), new Integer(3), new Integer(0),
    	"gg/mm/aaaa", new Integer(6), new Integer(3), new Integer(0),
    	"DD/MM/YYYY", new Integer(6), new Integer(3), new Integer(0),
    	"dd/mm/yyyy", new Integer(6), new Integer(3), new Integer(0),
    	"GG-MM-AAAA", new Integer(6), new Integer(3), new Integer(0),
    	"gg-mm-aaaa", new Integer(6), new Integer(3), new Integer(0),
    	"DD-MM-YYYY", new Integer(6), new Integer(3), new Integer(0),
    	"dd-mm-yyyy", new Integer(6), new Integer(3), new Integer(0),
    	"MM.GG.AAAA", new Integer(6), new Integer(0), new Integer(3),
    	"mm.gg.aaaa", new Integer(6), new Integer(0), new Integer(3),
    	"MM.DD.YYYY", new Integer(6), new Integer(0), new Integer(3),
    	"mm.dd.yyyy", new Integer(6), new Integer(0), new Integer(3),
    	"MM/GG/AAAA", new Integer(6), new Integer(0), new Integer(3),
    	"mm/gg/aaaa", new Integer(6), new Integer(0), new Integer(3),
    	"MM/DD/YYYY", new Integer(6), new Integer(0), new Integer(3),
    	"mm/dd/yyyy", new Integer(6), new Integer(0), new Integer(3),
    	"MM-GG-AAAA", new Integer(6), new Integer(0), new Integer(3),
    	"mm-gg-aaaa", new Integer(6), new Integer(0), new Integer(3),
    	"MM-DD-YYYY", new Integer(6), new Integer(0), new Integer(3),
    	"mm-dd-yyyy", new Integer(6), new Integer(0), new Integer(3)
    };
    /**
     * DataUtil constructor: data di sistema
     */
    public DataUtil() {
        Calendar d = Calendar.getInstance();
        String anno = new Integer(d.get(Calendar.YEAR)).toString();
        String mese = new Integer(d.get(Calendar.MONTH) + 1).toString();
        String giorno = new Integer(d.get(Calendar.DAY_OF_MONTH)).toString();
        if (mese.length() < 2)
            mese = "0" + mese;
        if (giorno.length() < 2)
            giorno = "0" + giorno;
        setDatainterna(anno + mese + giorno);
        now = d; // solo per questo costruttore
        valid = true;

    }
    /**
     * DataUtil constructor: da parametri int anno, mese, giorno
     */
    public DataUtil(int a, int m, int g) {

        String anno = new Integer(a).toString();
        String mese = new Integer(m).toString();
        String giorno = new Integer(g).toString();
        if (mese.length() < 2)
            mese = "0" + mese;
        if (giorno.length() < 2)
            giorno = "0" + giorno;
        if ((giorno.length() > 2) | (mese.length() > 2))
            datainterna = "";
        else
            setDatainterna(anno + mese + giorno);
        if (!verifydate()) {
            datainterna = "";
            valid = false;
        } else
        	valid = true;

    }

	/**
     * DataUtil constructor: data passata come stringa
     */
    public DataUtil(String d) {

		parsingDateString(d);

        if (!verifydate()) {
            datainterna = "";
            valid = false;
        } else
        	valid = true;

    }

	/**
     * DataUtil constructor: data passata come java.sql.Date
     */
    public DataUtil(Date d) {
    	Calendar ct = Calendar.getInstance();
    	ct.setTime(d);
        String anno = new Integer(ct.get(Calendar.YEAR)).toString();
        String mese = new Integer(ct.get(Calendar.MONTH) + 1).toString();
        String giorno = new Integer(ct.get(Calendar.DAY_OF_MONTH)).toString();
        if (mese.length() < 2)
            mese = "0" + mese;
        if (giorno.length() < 2)
            giorno = "0" + giorno;
        setDatainterna(anno + mese + giorno);

    	//setDatainterna(d.toString());

        if (!verifydate()) {
            datainterna = "";
            valid = false;
        } else
        	valid = true;

    }
	
	/**
     * DataUtil constructor: data passata come stringa e formato data
     */
    public DataUtil(String data, String format) {
        datainterna = "";
        valid = false;
    	for (int i=0; i<formats.length; i += 4) {
    		if (format.equals(formats[i])) {
    	        int pa = ((Integer)formats[i+1]).intValue();
    	        int pm = ((Integer)formats[i+2]).intValue();
    	        int pg = ((Integer)formats[i+3]).intValue();
    	        String anno = data.substring(pa, pa+4);
    	        String mese = data.substring(pm, pm+2);
    	        String giorno = data.substring(pg, pg+2);
    	        if (mese.length() < 2)
    	            mese = "0" + mese;
    	        if (giorno.length() < 2)
    	            giorno = "0" + giorno;
   	            setDatainterna(anno + mese + giorno);
    	        if (!verifydate()) {
    	            datainterna = "";
    	            valid = false;
    	        } else
    	        	valid = true;
    	        break;
    		}
    	}
    }
    
	/**
     * Aggiunge o toglie giorni alla data corrente.
     * Creation date: (9/6/01 9:54:29 AM)
     * @param days int
     */
    public void addDays(int days) {

        int mesi[] = new int[12];
        int anno;
        int mese;
        int giorno;

        mesi[0] = 31;
        mesi[1] = 28;
        mesi[2] = 31;
        mesi[3] = 30;
        mesi[4] = 31;
        mesi[5] = 30;
        mesi[6] = 31;
        mesi[7] = 31;
        mesi[8] = 30;
        mesi[9] = 31;
        mesi[10] = 30;
        mesi[11] = 31;

        if (datainterna.equalsIgnoreCase(""))
            return;

        anno = Integer.parseInt(getYear());
        mese = Integer.parseInt(getMonth()) - 1;
        giorno = Integer.parseInt(getDay());

        if (isBisestile(anno))
            mesi[1] = 29;

        if (days == 0)
            return;

        if (days < 0) { // valore parametro negativo = tolgo giorni alla data
            days = days * -1;
            if (days < giorno)
                giorno = giorno - days;
            else {
                while (days > 0) {
                    if (days < giorno) {
                        giorno = giorno - days;
                        days = 0;
                    } else {
                        days = days - giorno;
                        mese--;
                        if (mese < 0) {
                            anno--;
                            mese = 11;
                            if (isBisestile(anno))
                                mesi[1] = 29;
                        }
                        giorno = mesi[mese];
                    }
                }
            }
        } else {
            giorno = days + giorno;
            while (giorno > mesi[mese]) {
                giorno = giorno - mesi[mese];
                mese++;
                if (mese > 11) {
                    mese = 0;
                    anno++;
                    if (isBisestile(anno))
                        mesi[1] = 29;
                }
            }
        }

        mese++;
        setDatainterna(anno, mese, giorno);
    }
    
    /**
     * Aggiunge o toglie giorni alla data corrente.
     * Creation date: (9/6/01 3:59:46 PM)
     * @param days int
     */
    public void addDaysToDate(int days) {

        int anno;
        int mese;
        int giorno;

        if (datainterna.equalsIgnoreCase(""))
            return;

        anno = getIntYear();
        mese = getIntMonth() - 1;
        giorno = getIntDay();

        Calendar d = Calendar.getInstance();
        d.set(anno, mese, giorno);
        d.add(Calendar.DATE, days);

        anno = d.get(Calendar.YEAR);
        mese = d.get(Calendar.MONTH);
        giorno = d.get(Calendar.DAY_OF_MONTH);

        mese++;
        setDatainterna(anno, mese, giorno);

    }
    
    /**
     * Confronta la data corrente con quella del parametro:<br>
     * ritorna valore &gt; 0 se data &gt; data parametro <br>
     * ritorna valore &lt; 0 se data &lt; data parametro <br>
     * ritorna valore 0 se data = data parametro <br>
     * Creation date: (8/6/01 5:47:34 PM)
     * @return int
     * @param datetocompare rer.protocollo.beans.DataUtil
     */
    public int compareTo(DataUtil datetocompare) {

        String thisdate = this.getDatainterna();
        String tocomp = datetocompare.getDatainterna();

        return thisdate.compareTo(tocomp);

    }
    
    /**
     * ritorna la differenza in giorni tra data e data parametro.
     * Creation date: (9/6/01 4:07:55 PM)
     * @return int
     * @param data rer.protocollo.beans.DataUtil
     */
    public int diffDate(DataUtil data) {

        //data dell'oggetto
        int canno;
        int cmese;
        int cgiorno;
        //data parametro
        int panno;
        int pmese;
        int pgiorno;

        //differenza in giorni
        int diffdays = 0;

        boolean go;

        int giorni[] = new int[12];

        giorni[0] = 31;
        giorni[1] = 28;
        giorni[2] = 31;
        giorni[3] = 30;
        giorni[4] = 31;
        giorni[5] = 30;
        giorni[6] = 31;
        giorni[7] = 31;
        giorni[8] = 30;
        giorni[9] = 31;
        giorni[10] = 30;
        giorni[11] = 31;

        if (datainterna.equalsIgnoreCase(""))
            return 0;
        if (data.getDatainterna().equalsIgnoreCase(""))
            return 0;

        canno = getIntYear();
        cmese = getIntMonth() - 1;
        cgiorno = getIntDay();

        panno = data.getIntYear();
        pmese = data.getIntMonth() - 1;
        pgiorno = data.getIntDay();

        if (compareTo(data) == 0)
            return 0;

        if (compareTo(data) > 0) {
            // differenza positiva (questa data > di data parametro)
            go = true;
            while (go) {
                if (isBisestile(panno))
                    giorni[1] = 29;
                else
                    giorni[1] = 28;
                if (pgiorno < giorni[pmese]) {
                    diffdays++;
                    pgiorno++;
                } else {
                    diffdays++;
                    pgiorno = 1;
                    pmese++;
                    if (pmese > 11) {
                        panno++;
                        pmese = 0;
                        if (isBisestile(panno))
                            giorni[1] = 29;
                        else
                            giorni[1] = 28;
                    }
                }
                if ((panno == canno) & (pmese == cmese) & (pgiorno == cgiorno))
                    go = false;
            }

            return diffdays;
        } else {
            // differenza negativa (questa data < di data parametro)
            go = true;
            while (go) {
                if (isBisestile(canno))
                    giorni[1] = 29;
                else
                    giorni[1] = 28;
                if (cgiorno < giorni[cmese]) {
                    diffdays++;
                    cgiorno++;
                } else {
                    diffdays++;
                    cgiorno = 1;
                    cmese++;
                    if (cmese > 11) {
                        canno++;
                        cmese = 0;
                        if (isBisestile(canno))
                            giorni[1] = 29;
                        else
                            giorni[1] = 28;
                    }
                }
                if ((panno == canno) & (pmese == cmese) & (pgiorno == cgiorno))
                    go = false;
            }

            return (diffdays * -1);
        }
    }
    
    /**
     * ritorna la data in formato stringa per DB2: aaaa-mm-gg
     * Creation date: (8/6/01 12:26:44 PM)
     * @return java.lang.String
     */
    public java.lang.String getDataForDB2() {
        return datainterna;
    }
    
    /**
     * Ritorna la data in formato stringa per display in mappa: gg.mm.aaaa
     * Creation date: (8/6/01 12:45:24 PM)
     * @return java.lang.String
     */
    public String getDataForMap() {
    	return getDataForMap(".");
    }
    
    /**
     * Ritorna la data in formato stringa per display in mappa: gg.mm.aaaa
     * usa separatore sep
     * Creation date: (8/6/01 12:45:24 PM)
     * @return java.lang.String
     */
    public String getDataForMap(String sep) {

        String wtmp = getDatainterna();

        if (datainterna.equalsIgnoreCase(""))
            return "";

        if (wtmp != null) {
            String wdatas[] = new String[3];

            StringTokenizer std = new StringTokenizer(wtmp, "-");
            for (int i = 0; i < 3; i++) {
                wdatas[i] = std.nextToken();
            }

            //wtmp = wdatas[2] + "." + wdatas[1] + "." + wdatas[0];
            wtmp = wdatas[2] + sep + wdatas[1] + sep + wdatas[0];

        } else
            wtmp = "";

        return wtmp;

    }
    
    /**
     * ritorna la data nel formato interno (= a formato DB2)
     * Creation date: (8/6/01 12:26:44 PM)
     * @return java.lang.String
     */
    public java.lang.String getDatainterna() {
        return datainterna;
    }
	
	/**
	 * ritorna la data in formato java.sql.Date
	 */
	public Date getSQLDate() {
		Calendar c = Calendar.getInstance();
		c.set(this.getIntYear(),this.getIntMonth()-1,this.getIntDay());
		Date d = new Date(c.getTimeInMillis());
		return d;
	}
	
	/**
	 * ritorna i millisecondi corrispondenti alla data
	 */
	public long getTimeInMillis() {
		Calendar c = Calendar.getInstance();
		c.set(this.getIntYear(),this.getIntMonth()-1,this.getIntDay());
		return c.getTimeInMillis();
	}

	/**
	 * ritorna il Timestamp in formato java.sql.Timestamp
	 */
	public Timestamp getSQLTimestamp(){
		if (now == null) {
			Calendar c = Calendar.getInstance();
			c.set(this.getIntYear(),this.getIntMonth()-1,this.getIntDay());
			Timestamp ts = new Timestamp(c.getTimeInMillis());
			return ts;
		} else {
			Timestamp ts = new Timestamp(now.getTimeInMillis());
			return ts;
		}
	}
	
    /**
     * ritorna stringa con giorno
     * Creation date: (8/8/01 11:28:42 AM)
     * @return java.lang.String
     */
    public String getDay() {

        if (datainterna.equalsIgnoreCase(""))
            return "";

        String wd = this.getDatainterna();

        return wd.substring(8, 10);
    }
    
    /**
     * ritorna int giorno
     * Creation date: (8/8/01 11:28:42 AM)
     */
    public int getIntDay() {

        if (datainterna.equalsIgnoreCase(""))
            return 0;

        String wd = this.getDatainterna();

        return new Integer(wd.substring(8, 10)).intValue();
    }
    
    /**
     * ritorna int mese
     * Creation date: (8/8/01 11:28:42 AM)
     */
    public int getIntMonth() {

        if (datainterna.equalsIgnoreCase(""))
            return 0;

        String wd = this.getDatainterna();

        return new Integer(wd.substring(5, 7)).intValue();
    }
    
    /**
     * ritorna int anno
     * Creation date: (8/8/01 11:28:42 AM)
     * @return java.lang.String
     */
    public int getIntYear() {

        if (datainterna.equalsIgnoreCase(""))
            return 0;

        String wd = this.getDatainterna();

        return new Integer(wd.substring(0, 4)).intValue();
    }
    
    /**
     * ritorna stringa con mese
     * Creation date: (8/8/01 11:28:42 AM)
     * @return java.lang.String
     */
    public String getMonth() {

        if (datainterna.equalsIgnoreCase(""))
            return "";

        String wd = this.getDatainterna();

        return wd.substring(5, 7);
    }
    
    /**
     * ritorna stringa con anno
     * Creation date: (8/8/01 11:28:42 AM)
     * @return java.lang.String
     */
    public String getYear() {

        if (datainterna.equalsIgnoreCase(""))
            return "";

        String wd = this.getDatainterna();

        return wd.substring(0, 4);
    }
    
    /**
     * verifica se l'anno dell'oggetto data &egrave; bisestile (vero se si, falso se no)
     * Creation date: (9/6/01 2:57:14 PM)
     * @return boolean
     * @param anno int
     */
    private boolean isBisestile(int a) {

        float af = a;
        boolean century = false;
        boolean quarter = false;

        if (datainterna.equalsIgnoreCase(""))
            return false;

        if (a < 0 | a > 9999)
            return false;

        if ((af / 4) != (a / 4))
            return false;
        if ((af / 100) == (a / 100))
            century = true;
        if ((af / 400) == (a / 400))
            quarter = true;
        if (century == true & quarter == false)
            return false;

        return true;
    }
    
    /**
     * ritorna il boolean valid
     */
    public boolean isValid() {
    	return valid;
    }
    
    /**
     * Insert the method's description here.
     * Creation date: (06/09/2002 14.59.40)
     * @return boolean
     */
    public boolean isEndDate() {
        if (datainterna.equalsIgnoreCase(endDate))
            return true;
        else
            return false;
    }
    
    /**
     * Ritorna vero se la data &egrave; un giorno lavorativo (luned&igrave; - venerd&igrave;)
     * falso se fine settimana (sabato o domenica)
     * Creation date: (19/02/2002 9.13.33)
     */
    public boolean isWorkDay() {
        Calendar d = Calendar.getInstance();
        d.set(this.getIntYear(), this.getIntMonth() - 1, this.getIntDay());
        int day = d.get(Calendar.DAY_OF_WEEK);
        if ((day == 7) || (day == 1))
            return false;
        else
            return true;
    }
    
    /**
     * Ritorna in forma di oggetto DataUtil la data di inizio
     * dell'ora legale calcolata come ultima domenica di marzo
     */
    public DataUtil getOraLegaleStart() {
        return getOraLegale(2); //marzo
    }

    /**
     * Ritorna in forma di oggetto DataUtil la data di fine
     * dell'ora legale calcolata come ultima domenica di ottobre
     */
    public DataUtil getOraLegaleEnd() {
        return getOraLegale(9); //ottobre
    }
    
    private DataUtil getOraLegale(int mese) {
        Calendar d = Calendar.getInstance();
        d.set(this.getIntYear(), mese, 31); //31.mese anno corrente
        int day = d.get(Calendar.DAY_OF_WEEK);
        while (day != 1) {
        	d.add(Calendar.DATE,-1);
        	day = d.get(Calendar.DAY_OF_WEEK);
        }
        DataUtil ret = new DataUtil(this.getIntYear(),mese+1,d.get(Calendar.DATE));
        return ret;
    }
    

    /**
     * imposta nuova data interna a partire da parametri int: anno, mese, giorno
     * Creation date: (8/6/01 1:45:15 PM)
     */
    public void setDatainterna(int a, int m, int g) {

        String anno = new Integer(a).toString();
        String mese = new Integer(m).toString();
        String giorno = new Integer(g).toString();
        if (mese.length() < 2)
            mese = "0" + mese;
        if (giorno.length() < 2)
            giorno = "0" + giorno;
        if ((giorno.length() > 2) | (mese.length() > 2))
            datainterna = "";
        else
            setDatainterna(anno + mese + giorno);
        if (!verifydate())
            datainterna = "";

    }
    
    /**
     * imposta nuova data interna a partire da parametro stringa (formato: aaaa-mm-gg oppure gg.mm.aaaa)
     * Creation date: (8/6/01 12:26:44 PM)
     * @param newDatainterna java.lang.String
     */
    public void setDatainterna(java.lang.String d) {

		parsingDateString(d);
		
		if (!verifydate()) {
			datainterna = "";
			valid = false;
		} else
			valid = true;

    }
    
    /**
     * Verifica correttezza formale data.
     * Creation date: (8/6/01 2:21:53 PM)
     * @return boolean
     */
    public boolean verifydate() {

        // come faccio a verificare la correttezza della data? Forse usando la deprecata classe Date?
        String dt = getDatainterna();

        if (dt == null)
            return false;
        if (dt.length() < 10)
            return false;

        Integer a1 = new Integer(dt.substring(0, 4));
        Integer m1 = new Integer(dt.substring(5, 7));
        Integer g1 = new Integer(dt.substring(8, 10));
        int a = a1.intValue();
        int m = m1.intValue();
        int g = g1.intValue();
        float af = a;
        float mf = m;
        float gf = g;

        int err = 0;
        boolean century = false;
        boolean quarter = false;
        if (m < 1 | m > 12)
            err = 2;
        if (g < 1 | g > 31)
            err = 4;
        if (a < 0 | a > 9999)
            err = 6;
        //advanced error checking
        // months with 30 days
        if (m == 4 | m == 6 | m == 9 | m == 11) {
            if (g == 31)
                err = 7;
        }
        // february, leap year
        if (m == 2) {
            if (g > 29)
                err = 9;
            if (g == 29 & ((af / 4) != (a / 4)))
                err = 10;
            if ((af / 100) == (a / 100))
                century = true;
            if ((af / 400) == (a / 400))
                quarter = true;
            if (g == 29 & century == true & quarter == false) {
                err = 9;
            }
        }

        if (err > 0)
            return false;
        else
            return true;
    }

    /**
     * imposta coefficienti per il calcolo della pasqua
     * Creation date: (8/6/01 2:21:53 PM)
     * @return boolean
     */

    private void setCoeff(int anno) {
        if (anno < 1583) {
            coef1 = 24;
            coef2 = 6;
        } else if (anno < 1700) {
            coef1 = 22;
            coef2 = 2;
        } else if (anno < 1800) {
            coef1 = 23;
            coef2 = 3;
        } else if (anno < 1900) {
            coef1 = 23;
            coef2 = 4;
        } else if (anno < 2000) {
            coef1 = 24;
            coef2 = 5;
        } else if (anno < 2100) {
            coef1 = 24;
            coef2 = 5;
        } else if (anno < 2200) {
            coef1 = 24;
            coef2 = 6;
        } else if (anno < 2300) {
            coef1 = 25;
            coef2 = 0;
        } else if (anno < 2400) {
            coef1 = 26;
            coef2 = 1;
        } else if (anno < 2500) {
            coef1 = 25;
            coef2 = 1;
        } else if (anno < 2600) {
            coef1 = 26;
            coef2 = 2;
        }
    }

    
    /**
     * ritorna una stringa con l'indicazione della data della Pasqua
     * per l'anno della data interna.
     * @return
     */
    public String getPasqua() {
        int anno = this.getIntYear();
        int a, b, c, d, e;
        int mese;
        int giorno;

        if ((anno < 1) | (anno > 2599))
            return " non calcolabile";

        setCoeff(anno);

        a = anno % 19;
        b = anno % 4;
        c = anno % 7;
        d = (19 * a + coef1) % 30;
        e = (2 * b + 4 * c + 6 * d + coef2) % 7;
        if (22 + d + e <= 31) {
            mese = 3;
            giorno = 22 + d + e;
        } else {
            mese = 4;
            giorno = d + e - 9;
            if (giorno == 26)
                giorno = 19;
            if (giorno == 25 && a > 10 && d == 28)
                giorno = 18;
        }

        String flag = null;
        if ((giorno == 25) & (mese == 4)) {
            flag = "  <-- limite massimo";
        } else {
            if ((giorno == 22) & (mese == 3)) {
                flag = "  <-- limite minimo";
            } else {
                flag = "";
            }
        }
        pasqualim = flag;
        
        String pasquadate =
            new Integer(giorno).toString()
                + "."
                + new Integer(mese).toString()
                + "."
                + this.getYear();
        return pasquadate;
    }


	/**
	 * scompone la stringa e imposta data interna
	 * fa un parsing della stringa per tentare di indovinare
	 * anno mese e giorno
	 */
	private void parsingDateString(String d) {
		String wdatas[] = new String[3];
		int wdataval[] = new int[3];
        String token = null;
		int i = 0;
		int iy = -1;
		int im = -1;
		int id = -1;

		if (d == null) {
			datainterna = null;
			return;
		}

		StringTokenizer st = new StringTokenizer(d, "-:/. ");
		if (st.countTokens() < 3) {
			if (d.length() == 8) { //ipotizzo aaaammgg
				try {
					Integer x = new Integer(d.substring(0, 4));
					x = new Integer(d.substring(4, 6));
					x = new Integer(d.substring(6, 8));
					datainterna = d.substring(0, 4)+"-"+d.substring(4, 6)+"-"+d.substring(6, 8);
					return;
				} catch (NumberFormatException nfe) {
					datainterna = "";
					return;
				}
			} else {
				datainterna = "";
				return;
			}
		}
		//if (st.countTokens() != 3) {
		//	datainterna = "";
		//	return;
		//}

		while (st.hasMoreTokens()) {
			if (i > 2)		//legge solo la data anche se l'input � pi� lungo
				break;
            token = st.nextToken();
			if (token.length() == 4) {
				iy = i;
				wdatas[i++] = token;
			} else {
				if (token.length() < 2) 
					wdatas[i++] = "0"+token;
				else
					wdatas[i++] = token;
			}
		}
		
		if (iy == -1) {   	//anno su 2 caratteri non consentito
			datainterna = null;
			return;
		}
		
		for (int j=0; j<3; j++) {
			try {
				Integer x = new Integer(wdatas[j]);
				wdataval[j] = x.intValue();
			} catch(NumberFormatException nfe) {
				datainterna = null;
				return;
			}
		}
		
		int xpm = -1;
		int xpd = -1;
		for (int j=0; j<3; j++) {
			if (j != iy) {
				if (xpd == -1) {
					xpd = wdataval[j];
					id = j;
				} else {
					xpm = wdataval[j];
					im = j;
				}
			}
		}
		if ( (xpd == 0) || (xpm == 0) ) {
			datainterna = null;
			return;
		}
		
		if (xpm > 12) { 	//se il dato provvisorio per mese > 12 scambio gli indici giorno e mese
			int tid = id;
			int tim = im;
			id = tim;
			im = tid;
		}
		
		if( (iy == -1) || (im == -1) || (id == -1) ) 
			datainterna = null;
		else
			datainterna = wdatas[iy]+"-"+wdatas[im]+"-"+wdatas[id];
		
		return;	
	}
	
	/**
	 * metodo toString implementato per analogia, ritorna
	 * data interna memorizzata in formato stringa aaaa-mm-gg
	 */
	public String toString() {
		return datainterna;
	}
	public String getPasqualim() {
		return pasqualim;
	}

}
