package it.pf.utils;

import java.io.File;
import java.util.Comparator;

public class FilesComparator implements Comparator {

	private String path;
	
	/**
	 * Il costruttore riceve in input il path da anteporre al nome
	 * dei files/directories da confrontare
	 * @param p
	 */
	public FilesComparator(String p) {
		path = p;
	}
	
	/**
	 * Confronta i nomi di files e/o directories a scopo ordinamento,
	 * ritorna:
	 * -1 se o1 < o2	o1=file o2=dir
	 * 0  se o1 = o2	o1=file o2=file  o1=dir o2=dir
	 * 1  se o1 > o2	o1=dir  o2=file
	 */
	public int compare(Object o1, Object o2) {
		File f1 = new File(path+"/"+(String)o1);
		File f2 = new File(path+"/"+(String)o2);
		if ( (f1.isFile() && f2.isFile()) ||
			 (f1.isDirectory() && f2.isDirectory()) ) {
			// string comparision
			String s1 = (String)o1;
			String s2 = (String)o2;
			return s1.toLowerCase().compareTo(s2.toLowerCase());			
		} else if ( f1.isFile() && f2.isDirectory() ) {
			return 1; //file segue directory
		} else {
			return -1;
		}
	}

}
