package it.pf.utils;

import it.pf.base.ObjectBean;

import java.io.File;
import java.net.MalformedURLException;
import java.net.URL;
import java.net.URLClassLoader;
import java.util.Arrays;
import java.util.Enumeration;
import java.util.Properties;

public class JarFileLoader extends URLClassLoader {

	public JarFileLoader(URL[] urls) {
		super(urls);
	}

	public void addFile(String path) throws MalformedURLException {
		this.add(path);
	}
	
	public void addDirFiles(String dirPath) throws MalformedURLException {
		if (dirPath != null) {
			File dir = new File(dirPath);
			if (dir.isDirectory()) {
				String abspath = dir.getAbsolutePath();
				String[] fns = sortedFileList(dir,abspath);
				abspath = abspath.replace('\\','/');
				for (int i=0; i<fns.length; i++) {
					String fpath = abspath+"/"+fns[i];
					File f = new File(fpath);
					if (f.isFile()) {
						if (fpath.endsWith(".jar")) {
							this.add(fpath);
						}
					}
				}
			}
		}
	}

	private void add(String path)  throws MalformedURLException {
		String urlPath = "jar:file://" + path +"!/";
		addURL(new URL(urlPath));
	}
	
	private String[] sortedFileList(File dir, String path) {
		FilesComparator fc = new FilesComparator(path);
		String[] f = dir.list();
		Arrays.sort(f,fc);
		return f;
	}

	/**
	 * @param args
	 * @throws MalformedURLException 
	 */
	public static void main(String[] args) throws MalformedURLException {
		URL[] urls = {};
		JarFileLoader inst = new JarFileLoader(urls);
		inst.addDirFiles(args[0]);
		urls = inst.getURLs();
		for (int i=0; i<urls.length; i++) {
			System.out.println(urls[i].toString());
		}
		/*
		Properties props = System.getProperties();
		Enumeration propNames = props.propertyNames();
		while (propNames.hasMoreElements()) {
			String name = (String) propNames.nextElement();
			System.out.println(name + " ["
					+ System.getProperty(name) + "]");
		}
		*/
	}

}
