package it.pf.utils;


import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;
import java.util.Calendar;

public class PasswordGenerator {

	private String message;
	
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		String hash = null;
		PasswordGenerator inst = null;
		if (args.length == 0) {
			inst = new PasswordGenerator();
		} else {
			inst = new PasswordGenerator(args[0]);
		}
		System.out.println(" Message is:"+inst.getMessage());
		hash = inst.getHashed();
		System.out.println("Password is:"+hash);
		inst.showParts(hash);
	}

	public PasswordGenerator() {
		Calendar now = Calendar.getInstance();
		message = now.toString();
	}
	
	public PasswordGenerator(String arg) {
		if (arg.length() > 4) {
			message = arg;
		} else {
			Calendar now = Calendar.getInstance();
			message = now.toString();
		}
	}
	

	public String getHashed() {
		byte[] bh = this.compute();
		return this.toHex(bh);
	}
	
	private byte[] compute() {
		try {
			MessageDigest md = MessageDigest.getInstance("SHA-512");
			md.update(message.getBytes());
			return md.digest();
		} catch (NoSuchAlgorithmException e) {
			e.printStackTrace();
			return null;
		}
	}
	
	private String toHex(byte[] in) {
		StringBuffer out = new StringBuffer(in.length * 2);
		byte ch = 0x00;
	    String pseudo[] = {"0", "1", "2",
	    		"3", "4", "5", "6", "7", "8",
	    		"9", "A", "B", "C", "D", "E",
	    		"F"};
		for (int i = 0; i<in.length; i++) {
			ch = (byte) (in[i] & 0xF0); // Strip off high nibble
			ch = (byte) (ch >> 4);     // shift the bits down
			ch = (byte) (ch & 0x0F);    // must do this is high order bit is on!
	        out.append(pseudo[ (int) ch]); // convert the	nibble to a String Character
	        ch = (byte) (in[i] & 0x0F); // Strip off low nibble 
	        out.append(pseudo[ (int) ch]); // convert the nibble to a String Character		
	    }
		return out.toString();
	}

	public String getMessage() {
		return message;
	}

	public void setMessage(String message) {
		this.message = message;
	}
	
	public void showParts(String hash) {
		int p=0;
		int count = 1;
		while ((p+1) < hash.length()) {
			System.out.println(count+"-"+hash.substring(p, p+8));
			p += 8;
			count++;
		}
	}

}
