package it.pf.utils;

import java.util.Date;
import java.util.Properties;

import it.pf.base.ConfigSingleton;
import it.pf.base.ObjectBean;
import javax.mail.*;
import javax.mail.internet.*;
import javax.activation.*;


public class SendMail {

	private String hostName;
	private Session session;
	private MimeMessage message;
	private static boolean debug = true;
	
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		String from = "pfabbri@regione.emilia-romagna.it";
		String to = "pfabbri@regione.emilia-romagna.it";
		String subject = "Ciao.";
		String text = "Salve.";
		//SendMail inst = new SendMail(args[0]);
		SendMail inst = new SendMail();
		//inst.setHostName("sin815srv.ente.regione.emr.it");
		inst.setHostName("sin92exc.regione.emilia-romagna.it");
		inst.init();
		inst.sendMessage(from,to,subject,text);
		//inst.sendMessage(from,to,subject,text,args[0]);
		//inst.newMessage();
		//inst.setMessageFrom(from);
		//inst.setMessageTo(to);
		//inst.setMessageSubject(subject);
		//inst.setMessageText(text);
		//inst.setMessageAttachement(args[0]);
		//inst.sendMessage(inst.getMessage());
	}

	public SendMail() {		
	}
	
	public SendMail(boolean dbg) {
		debug = dbg;
	}
	
	public SendMail(String configFile) {
		ConfigSingleton.setConfigFileName(configFile);
		ObjectBean config = null;
		try {
			config = new ObjectBean(ObjectBean.fromXMLFile(configFile));
			ConfigSingleton.setResources(config);
			ConfigSingleton.getInstance();
			ObjectBean bx = ConfigSingleton.getResources().getFilteredAttribute("CONFIG:VARIE:PARAMETER","name","mail.smtp.host");
			this.setHostName((String)bx.getAttributeValue("value"));
		} catch (Exception e) {
			e.printStackTrace();
		}				
	}

	public SendMail(String configFile, boolean dbg) {
		ConfigSingleton.setConfigFileName(configFile);
		ObjectBean config = null;
		try {
			config = new ObjectBean(ObjectBean.fromXMLFile(configFile));
			ConfigSingleton.setResources(config);
			ConfigSingleton.getInstance();
			ObjectBean bx = ConfigSingleton.getResources().getFilteredAttribute("CONFIG:VARIE:PARAMETER","name","mail.smtp.host");
			this.setHostName((String)bx.getAttributeValue("value"));
			debug = dbg;
		} catch (Exception e) {
			e.printStackTrace();
		}				
	}
	
	public void init() {
		Properties props = new Properties();
		props.put("mail.smtp.host", this.getHostName());
		Session session = Session.getDefaultInstance(props, null);
		session.setDebug(debug);	
		this.setSession(session);
		return;
	}

	public boolean sendMessage(String from, String to, String subject, String text) {
		try {
			MimeMessage msg = new MimeMessage(this.getSession());
			msg.setFrom(new InternetAddress(from));
			InternetAddress[] address = {new InternetAddress(to)};
			msg.setRecipients(Message.RecipientType.TO, address);
			msg.setSubject(subject);
			msg.setSentDate(new Date());

			MimeBodyPart mbp1 = new MimeBodyPart();
			mbp1.setText(text);

			Multipart mp = new MimeMultipart();

			mp.addBodyPart(mbp1);

			msg.setContent(mp);

			Transport.send(msg);
			
			return true;
		} catch (MessagingException mex) {
			mex.printStackTrace();
			Exception ex = null;
			if ((ex = mex.getNextException()) != null) {
				ex.printStackTrace();
			}
			return false;
		}
	}
	
	public boolean sendMessage(String from, String to, String subject, String text, String file) {
		try {
			MimeMessage msg = new MimeMessage(this.getSession());
			msg.setFrom(new InternetAddress(from));
			InternetAddress[] address = {new InternetAddress(to)};
			msg.setRecipients(Message.RecipientType.TO, address);
			msg.setSubject(subject);
			msg.setSentDate(new Date());

			MimeBodyPart mbp1 = new MimeBodyPart();
			mbp1.setText(text);

			Multipart mp = new MimeMultipart();

			mp.addBodyPart(mbp1);

			MimeBodyPart mbp2 = new MimeBodyPart();
			DataSource sorgente = new FileDataSource(file);
			DataHandler dh = new DataHandler(sorgente);
			mbp2.setDataHandler(dh);
			
			String filename = null;
			int p = file.lastIndexOf("\\");
			if (p == 0)
				p = file.lastIndexOf("/");
			if (p > 0)
				filename = file.substring(p+1);
			else
				filename = file;
			mbp2.setFileName(filename);
			
			mp.addBodyPart(mbp2);
			
			msg.setContent(mp);

			Transport.send(msg);
			
			return true;
		} catch (MessagingException mex) {
			mex.printStackTrace();
			Exception ex = null;
			if ((ex = mex.getNextException()) != null) {
				ex.printStackTrace();
			}
			return false;
		}
	}

	public void newMessage() {
		MimeMessage msg = new MimeMessage(this.getSession());
		try {
			msg.setSentDate(new Date());
		} catch (MessagingException e) {
			e.printStackTrace();
		}
		this.setMessage(msg);
	}
	
	public boolean setMessageFrom(String from) {
		MimeMessage msg = this.getMessage();
		if (msg == null) { 
			newMessage();
			msg = this.getMessage();
		}
		try {
			msg.setFrom(new InternetAddress(from));
			this.setMessage(msg);
			return true;
		} catch (AddressException e) {
			e.printStackTrace();
			return false;
		} catch (MessagingException e) {
			e.printStackTrace();
			return false;
		}
	}
	
	public boolean setMessageTo(String to) {
		MimeMessage msg = this.getMessage();
		if (msg == null) { 
			newMessage();
			msg = this.getMessage();
		}
		try {
			InternetAddress[] address = {new InternetAddress(to)};
			msg.setRecipients(Message.RecipientType.TO, address);
			this.setMessage(msg);
			return true;
		} catch (AddressException e) {
			e.printStackTrace();
			return false;
		} catch (MessagingException e) {
			e.printStackTrace();
			return false;
		}
	}

	public boolean setMessageTo(String to, String where) {
		MimeMessage msg = this.getMessage();
		if (msg == null) { 
			newMessage();
			msg = this.getMessage();
		}
		try {
			InternetAddress[] address = {new InternetAddress(to)};
			if (where.equalsIgnoreCase("TO"))
				msg.setRecipients(Message.RecipientType.TO, address);
			else if (where.equalsIgnoreCase("CC"))
				msg.setRecipients(Message.RecipientType.CC, address);
			else if (where.equalsIgnoreCase("BCC"))
				msg.setRecipients(Message.RecipientType.BCC, address);
			else
				msg.setRecipients(Message.RecipientType.TO, address);
			this.setMessage(msg);
			return true;
		} catch (AddressException e) {
			e.printStackTrace();
			return false;
		} catch (MessagingException e) {
			e.printStackTrace();
			return false;
		}
	}

	public boolean setMessageSubject(String subject) {
		MimeMessage msg = this.getMessage();
		if (msg == null) { 
			newMessage();
			msg = this.getMessage();
		}
		try {
			msg.setSubject(subject);
			this.setMessage(msg);
			return true;
		} catch (AddressException e) {
			e.printStackTrace();
			return false;
		} catch (MessagingException e) {
			e.printStackTrace();
			return false;
		}
	}


	public boolean setMessageText(String text) {
		MimeMessage msg = this.getMessage();
		if (msg == null) { 
			newMessage();
			msg = this.getMessage();
		}
		try {
			MimeBodyPart mbp1 = new MimeBodyPart();
			mbp1.setText(text);

			Multipart mp = null;
			try {
				mp = (Multipart)msg.getContent();
			} catch (Exception ex) {
				mp = null;
			}
			if (mp == null)
				mp = new MimeMultipart();

			mp.addBodyPart(mbp1);

			msg.setContent(mp);

			this.setMessage(msg);
			
			return true;
		} catch (Exception e) {
			e.printStackTrace();
			return false;
		} 
	}


	public boolean setMessageAttachement(String file) {
		MimeMessage msg = this.getMessage();
		if (msg == null) { 
			newMessage();
			msg = this.getMessage();
		}
		try {
			MimeBodyPart mbp1 = new MimeBodyPart();
			DataSource sorgente = new FileDataSource(file);
			DataHandler dh = new DataHandler(sorgente);
			mbp1.setDataHandler(dh);
			
			String filename = null;
			int p = file.lastIndexOf("\\");
			if (p == 0)
				p = file.lastIndexOf("/");
			if (p > 0)
				filename = file.substring(p+1);
			else
				filename = file;
			mbp1.setFileName(filename);

			Multipart mp = null;
			try {
				mp = (Multipart)msg.getContent();
			} catch (Exception ex) {
				mp = null;
			}
			if (mp == null)
				mp = new MimeMultipart();

			mp.addBodyPart(mbp1);

			msg.setContent(mp);

			this.setMessage(msg);
			
			return true;
		} catch (Exception e) {
			e.printStackTrace();
			return false;
		} 
	}

	public boolean sendMessage(MimeMessage msg) {
		try {
			Transport.send(msg);
			return true;
		} catch (MessagingException mex) {
			mex.printStackTrace();
			Exception ex = null;
			if ((ex = mex.getNextException()) != null) {
				ex.printStackTrace();
			}
			return false;
		}
	}

	public String getHostName() {
		return hostName;
	}

	public void setHostName(String hostName) {
		this.hostName = hostName;
	}

	public Session getSession() {
		return session;
	}

	public void setSession(Session session) {
		this.session = session;
	}

	public MimeMessage getMessage() {
		return message;
	}

	public void setMessage(MimeMessage message) {
		this.message = message;
	}
}
