package it.pf.utils;

import java.util.Collections;
import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.List;
import java.util.Vector;
/**
 * implementa un'hashtable capace di contenere chiavi (stringhe di caratteri) e contatori
 * @author paolo
 *
 */
public class Statistics {

	private Hashtable stats;
	
	public Statistics() {
		stats = new Hashtable();
	}
	
	/**
	 * aggiunge 1 alla chiave passata come parametro
	 * @param krc
	 */
	public void add(String krc) {
		Integer k = (Integer)stats.get(krc);
		if (k == null) {
			stats.put(krc, new Integer(1));
		} else {
			int kv = k.intValue();
			kv++;
			Integer nk = new Integer(kv);
			stats.put(krc, nk);
		}
	}

	/**
	 * aggiunge 'value' alla chiave passata come primo parametro
	 * @param krc
	 * @param value
	 */
	public void add(String krc, int value) {
		Integer k = (Integer)stats.get(krc);
		if (k == null) {
			stats.put(krc, new Integer(value));
		} else {
			int kv = k.intValue();
			kv += value;
			Integer nk = new Integer(kv);
			stats.put(krc, nk);
		}
	}

	/**
	 * mostra la statistica, ovvero l'elenco delle chiavi e relativi contatori 
	 * ordinata in ordine crescente di chiave
	 */
	public void show() {
		Enumeration keys = stats.keys();
		Vector vo = new Vector();
		while (keys.hasMoreElements()) {
			String krc = (String)keys.nextElement();
			Integer kv = (Integer)stats.get(krc);
			String out = krc+"="+kv.toString();
			vo.add(out);
			//System.out.println(krc+"="+kv.intValue());
		}
		Collections.sort((List)vo);
		Iterator itvo = vo.iterator();
		System.out.println("**********Statistics*************");
		while (itvo.hasNext()) {
			String k = (String)itvo.next();
			System.out.println(k);		
		}
		System.out.println("**********Statistics - end******");
	}
	
}
