package test;

import java.lang.reflect.Method;
import java.sql.Types;
import java.util.ArrayList;

import it.eng.fs.constant.LXConstants;
import it.eng.fs.exeption.CallException;
import it.eng.fs.exeption.ConfigException;
import it.eng.fs.services.PianoColturale;
import it.eng.fs.stub.GetPianoColturale;
import it.eng.fs.stub.GetPianoColturaleResponse;
import it.eng.fs.stub.ISWSMacrouso;
import it.eng.fs.stub.ISWSPossesso;
import it.eng.fs.stub.ISWSResponse;
import it.eng.fs.stub.ISWSUtilizzo;
import it.pf.dbaccess.DataField;
import it.pf.dbaccess.DataRow;
import it.pf.dbaccess.DataSheet;

public class MainProcess {

	private String RC_OK = "012";
	
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		MainProcess instance = new MainProcess();
		instance.execute(args[0], args[1]);
	}

	public void execute(String cuaa, String anno) {
		int annoRiferimento = (new Integer(anno)).intValue();
		PianoColturale client = new PianoColturale();
		client.setPortName(LXConstants.PORT_NAME_DEFAULT);
		client.setAddressPoint(LXConstants.PROTOCOL_AGREA+"://"+LXConstants.IP_AGREA+":"+LXConstants.PORT_AGREA+"/"+LXConstants.SERVICE_AGREA_END_POINT);
		//Configurazione del client per il wss security
		try {
			client.configure();
			client.setTimeOut(10000);
		} catch (ConfigException e) {
			e.printStackTrace();
		}
		GetPianoColturale input = new GetPianoColturale();
		input.setCuaa(cuaa);
		input.setAnnoRiferimento(annoRiferimento);
		//input.setScaricaAzienda(true);
		input.setScaricaUtilizzi(true);
		//input.setScaricaZone(true);
		
		
		GetPianoColturaleResponse response=null;
		
	
		try {
			//Invocazione del servizio
			response = client.execute(input);
								
			//Stampa messaggi soap request e reaponse
			System.out.println("*****REQUEST*****");
			System.out.println(client.getRequestSOAP());
			System.out.println("*****RESPONSE*****");
			System.out.println(client.getResponseSOAP());
		} catch (CallException e) {
			e.printStackTrace();
			return;
		}
		
		//return;
		
		try{
			
			ISWSResponse res=response.getGetPianoColturaleReturn();
					
			Keys chiave = new Keys(1);
			chiave.addKey("CUAA",cuaa);
			
			//Processo la risposta e mi recupero tutti i possessi, e per ogni possesso tutti i macrousi a esso associato.
			//Creo un SourceBean contenente i valori sopra citati.
			if(res!=null){
				String codRet = res.getCodRet();
				if (!codRet.equals(RC_OK)) {
					System.out.println("Errore:"+codRet+" - "+res.getMsgRet());
					return;
				} 
				DataSheet output = new DataSheet(2000);
				ISWSPossesso possessi_arr[]=res.getPossessi();
				if(possessi_arr !=null && possessi_arr.length>0){
					for(int i=0;i<possessi_arr.length;i++){
						int counter = 0;
						UtilizziFlat pc = new UtilizziFlat();
						copyBean(possessi_arr[i], pc);
						System.out.println("--");

						ISWSMacrouso[] macro=possessi_arr[i].getMacrousi();
						if(macro !=null && macro.length>0){				
							for(int j=0; j<macro.length; j++){
								copyBean(macro[j], pc);
								System.out.println("  --");
								ISWSUtilizzo[] utilizzi = macro[j].getUtilizzi();
								if (utilizzi != null && utilizzi.length>0) {
									for(int k=0; k<utilizzi.length; k++){
										copyBean(utilizzi[k], pc);
										System.out.println("PC__"+counter++);
										System.out.println(pc.toString());
										output.addRow(mapObj2DataRow(chiave, pc));
									}
								} else {
									System.out.println("PC__"+counter++);
									System.out.println(pc.toString());
									output.addRow(mapObj2DataRow(chiave, pc));
								}
							}						
						} else {
							System.out.println("PC__"+counter++);
							System.out.println(pc.toString());
							output.addRow(mapObj2DataRow(chiave, pc));
						}
					}				
					output.writeXLS("/home/paolo/tmp/pc.xls");
				}
			}	
				
		}catch(Exception e){
			e.printStackTrace();
		}
		return;
	}
	
	
	protected void copyBean(Object from, Object to) throws java.lang.Exception {
    	Method[] methods = (from.getClass()).getMethods();
    	for (int j=0; j<methods.length; j++){
			Method methodget = ((Method)methods[j]);
			String nome = methodget.getName();
			if (nome!=null && nome.startsWith("get")){
				if (!nome.equals("getSerializer") &&
						!nome.equals("getDeserializer") &&
						!nome.equals("getOMElement") &&
						!nome.equals("getPullParser") &&
						!nome.equals("getTypeDesc") &&
						!nome.equals("getSerializer") &&
						!nome.equals("getClass") &&
						!nome.equals("getClasse")
				) {
					Object value = methodget.invoke(from, null);
					if (value != null) {
						try {
							Method methodset = (to.getClass()).getMethod("set"+methodget.getName().substring(3), value.getClass());
							if (methodset != null) {
								methodset.invoke(to,value);
							}
						} catch (NoSuchMethodException nm) {
							//donothing
						}
					}
				} 
			}
		}
	}

	protected DataRow mapObj2DataRow(Keys keys, Object obj) throws java.lang.Exception {
    	Method[] methods = (obj.getClass()).getMethods();
    	ArrayList names = new ArrayList();
    	ArrayList values = new ArrayList();
    	for (int j=0; j<methods.length; j++){
			Method method = ((Method)methods[j]);
			String nome = method.getName();
			if (nome!=null && nome.startsWith("get")){
				if (!nome.equals("getSerializer") &&
						!nome.equals("getDeserializer") &&
						!nome.equals("getOMElement") &&
						!nome.equals("getPullParser") &&
						!nome.equals("getTypeDesc") &&
						!nome.equals("getSerializer") &&
						!nome.equals("getClass") &&
						!nome.equals("getClasse")
				){
					Class rc = method.getReturnType();
					String t = rc.getName();
					if (t.equals("java.math.BigInteger")
						|| t.equals("java.math.BigDecimal")
						|| t.endsWith("java.lang.String")) {
						Object res = method.invoke(obj, null);
						if (res instanceof Object[] ){
							//donothing
						}else {   //if (res != null){
							names.add(nome.substring(3));
							values.add(res);
						}
					}
				} 
			}
		}
    	DataRow dr = null;
    	int pos = 0;
    	if (keys != null) {
	    	dr = new DataRow(names.size()+keys.size());
	    	for (int i=0; i<keys.size(); i++) {
	    		String fname = keys.getName(i);
	    		int type = Types.VARCHAR;
	    		Object dato = keys.getValue(i);
	    		if (dato instanceof String) {
	    			type = Types.VARCHAR;
	    		} else if (dato instanceof Integer) {
	    			type = Types.INTEGER;
	    		} else if (dato instanceof java.math.BigInteger) {
	    			type = Types.INTEGER;
	    		} else if (dato instanceof java.math.BigDecimal) {
	    			type = Types.DECIMAL;
	    		} else {
	    			type = Types.VARCHAR;
	    		}
	        	DataField keydf = new DataField(fname,type,dato);
	        	dr.addColumn(pos++, keydf);
	    	}
    	} else {
	    	dr = new DataRow(names.size());
    	}
    	for (int i=0; i<names.size(); i++) {
    		int type = Types.VARCHAR;
    		Object dato = values.get(i);
    		if (dato instanceof String) {
    			type = Types.VARCHAR;
    		} else if (dato instanceof Integer) {
    			type = Types.INTEGER;
    		} else if (dato instanceof java.math.BigInteger) {
    			type = Types.INTEGER;
    		} else if (dato instanceof java.math.BigDecimal) {
    			type = Types.DECIMAL;
    		} else {
    			type = Types.VARCHAR;
    		}
    		DataField df = new DataField((String)names.get(i),type,dato);
    		dr.addColumn(i+pos, df);
    	}
		return dr;
	}

}
